<?php



    // google reCAPTCHA - https://developers.google.com/recaptcha/intro
    // to use captcha put your SiteKey and SecretKey provided by Google in the variables below and set enable variable to 1
    // todo - add reCAPTCHA v3 suppport - use enable key to allow version switching
    $google_invisible_captcha_enable=0;
    $google_invisible_captcha_sitekey = 'MySiteKey';
    $google_invisible_captcha_secret = 'MySecrectKey';
    if ($google_invisible_captcha_enable>0){
        $page_meta.="<script src='https://www.google.com/recaptcha/api.js'></script>
        <script>
        function submitCaptchaForm() {
            document.getElementById(\"contactForm\").submit();
        }
        </script>";
    }

    // exit if php file is loaded directly and not included
    if (!defined("cms_version_number")){exit();}

			  	// post property data on submit
    			if (isset($_POST['contact_form_submit'])){

                    // clean input variables
                    $civ['name']=sanitize_text_input($_POST['name']);
                    $civ['email']=sanitize_text_input($_POST['email']);
                    $civ['phone']=sanitize_text_input($_POST['phone']);
                    $civ['message']=sanitize_text_input($_POST['message']);

                    // check that GDPR checkbox is checked
                    if ($cms_settings['gdpr']==2 && !isset($rvi_gdpr_consent)){
                        $_SESSION['form']['contact_warning'][]="Your consent is required to comply with GDPR guidelines. Please tick the privacy policy checkbox to proceed.";
                    }

					require_once(cms_root_dir."scripts/emailval.php");

					// check values
					if (strlen($civ['name'])<2){$_SESSION['form']['contact_warning'][]="Please enter your name";}
					if (MailVal($civ['email'], 2)){$_SESSION['form']['contact_warning'][]="Please enter your email address";}
					// check phone number
					$clearchars=array('-',',',' ','-','+','(',')');
					if (intval(str_replace($clearchars,"",$civ['phone']))<10000 || substr($civ['phone'],0,5)=="12345"){$_SESSION['form']['contact_warning'][]="Please enter your phone number";}
					if (strlen($civ['message'])<5){$_SESSION['form']['contact_warning'][]="Your message is too short";}
					if (strlen($civ['message'])>5000){$_SESSION['form']['contact_warning'][]="Your message is too long";}
					// check for spam in message
                    $anti_spam_fn=cms_root_dir.'admin/includes/anti-spam.txt';
                    if (file_exists($anti_spam_fn)){
                        $check_message=strtolower($civ['message']);
                        $anti_spam_words=file($anti_spam_fn);
                        $instance_limit=0;


                        foreach ($anti_spam_words as $spam_word){

                            $spam_word=trim($spam_word);

                            if ($spam_word=='' || substr($spam_word,0,2)=='//'){continue;}

                            if (substr($spam_word,0,23)=='blocked_character_sets='){
                                // preg_match /p pattern only works from php5.1 version
                                if (version_compare(PHP_VERSION, '5.1.0') >= 0){
                                    $blocked_character_sets=explode(',',substr($spam_word,23));
                                    foreach ($blocked_character_sets as $blocked_character_set){
                                        $blocked_character_set=trim($blocked_character_set);
                                        if (preg_match( '/[\p{'.$blocked_character_set.'}]/u', $check_message)){
                                            $blocked_message=1;
                                            //update_log('Contact form spam filter blocked message due to '.$blocked_character_set.' character set');
                                            $_SESSION['form']['contact_warning'][]="Message contains unsupported characters or language. Please edit your message or <a href=\"mailto:".$cms_settings['config']['site_email']."\">email us directly</a>.";
                                            break;
                                        }
                                    }
                                }
                                continue;
                            }
                            if (isset($blocked_message)){break;}

                            $spam_word=strtolower($spam_word);

                            // check for change to instance limit
                            if (substr($spam_word,0,15)=='instance_limit='){
                                $pieces=explode('=',$spam_word);
                                $instance_limit=intval($pieces[1]);
                            }
                            if ($instance_limit<1){
                                if (strpos($check_message,$spam_word)!==FALSE){
                                    $_SESSION['form']['contact_warning'][]="Message contains spam filtered words. Please remove the word &quot;".$spam_word."&quot; or <a href=\"mailto:".$cms_settings['config']['site_email']."\">email us directly</a>.";
                                    break;
                                }
                            }
                            else{
                                if (substr_count($check_message,$spam_word)>$instance_limit){
                                    //$_SESSION['form']['contact_warning'][]="Spam filter has found too many &quot;http&quot; entries in message. Please edit your message or <a href=\"mailto:".$cms_settings['config']['site_email']."\">email us directly</a>.";
                                    $_SESSION['form']['contact_warning'][]="Spam filter has found too many instances of &quot;".$spam_word."&quot; in message. Please edit your message or <a href=\"mailto:".$cms_settings['config']['site_email']."\">email us directly</a>.";
                                    break;
                                }
                            }
                        }

                    }

                    // spam filter block high mailing volume/frequency in same session
                    if (isset($_SESSION['sentemail'])){

                        $email_count=count($_SESSION['sentemail']);

                        if ($email_count>10){$_SESSION['form']['contact_warning'][]="Spam filter has blocked this message due to high volume. Please try again later or contact us directly by email or phone.";}
                        else{
                            // check time since last sent email
                            $last_email_time=time()-$_SESSION['sentemail'][$email_count-1];
                            // wait time in seconds, the more emails sent in the same session the longer the wait time
                            $wait_time=$email_count*9;
                            if ($last_email_time<$wait_time){$_SESSION['form']['contact_warning'][]="Spam filter has blocked this message due to high frequency. Please try again in a while or contact us directly by email or phone.";}
                        }

                    }

                    // google recaptcha check
                    if ($google_invisible_captcha_enable>0){
                        if(isset($_POST['g-recaptcha-response'])){
                            $response = $_POST['g-recaptcha-response'];
                            $remoteIp = $_SERVER['REMOTE_ADDR'];

                            $reCaptchaValidationUrl = file_get_contents("https://www.google.com/recaptcha/api/siteverify?secret=$google_invisible_captcha_secret&response=$response&remoteip=$remoteIp");
                            $result = json_decode($reCaptchaValidationUrl, TRUE);

                            if($result['success']!=1){$_SESSION['form']['contact_warning'][]="There was a problem validating the form.";}
                        }
                        else{$_SESSION['form']['contact_warning'][]="There was a problem validating the form.";}
                    }

					if (!isset($_SESSION['form']['contact_warning'])){

                        require_once(cms_root_dir.'plugins/PHPMailer/class.phpmailer.php');

                        $mail = new PHPMailer();

                        // send mail via smtp if set in config file
                        if (defined('smtp_host')){
                            $mail->IsSMTP(); // send via SMTP
                            $mail->SMTPAuth = true; // turn on SMTP authentication
                            $mail->SMTPSecure = 'ssl';
                            $mail->Username = smtp_username; // SMTP username
                            $mail->Password = smtp_password; // SMTP password
                            $mail->Host       = smtp_host; // SMTP server
                            $mail->Port       = smtp_port; // SMTP server
                        }

                        $mail->ClearAddresses();
                        $mail->ClearAttachments();

                        // send user confirmation email
                        $mail->From = $cms_settings['config']['site_email'];
                        $mail->FromName = cms_site_name;

                        $mail->AddAddress($cms_settings['config']['site_email']);
                        $mail->AddReplyTo($civ['email'], $civ['name']);

                        if (isset($subject)){$mail->Subject = $subject;}
                        else{$mail->Subject = "Message from ".cms_site_name." contact form";}

                        $newsletter_consent="";
                        if ($cms_settings['newsletter_consent']>0){
                            if (isset($rvi_newsletter_consent)){$newsletter_consent="\nNewsletter Consent: Yes";}
                            else{$newsletter_consent="\nNewsletter Consent: Not given";}
                        }

                        $mail->Body    = "IP: ".$_SERVER['REMOTE_ADDR']."\n\nName: ".stripslashes($civ['name'])."\nEmail: ".$civ['email']."\nPhone: ".$civ['phone'].$newsletter_consent."\n\n".stripslashes(strip_tags($civ['message']));
                        $mail->IsHTML(false);

                        if(!$mail->Send()){
                            if(isset($_SESSION['reg_user'])){update_log("Failed to send email from user ".short_name($_SESSION['reg_user']['name'],2)." ".$_SESSION['reg_user']['id']." via contact form");}
                            else{update_log('Failed to send email from guest via contact form');}
                            $_SESSION['form']['contact_warning'][]="Warning: message could not be sent. Please contact us directly by email or phone.";
                            //echo "Message could not be sent. <p>";
                            //echo "Mailer Error: " . $mail->ErrorInfo;
                            //exit;
                        }
                        else{
                            if(isset($_SESSION['reg_user'])){update_log("Email sent from ".short_name($_SESSION['reg_user']['name'],2)." ".$_SESSION['reg_user']['id']." via contact form");}
                            else{update_log("Email sent from guest via contact form");}
    						$_SESSION['form']['contact_warning_green'][]="<h2>Thank You</h2><p>Your message has been sent. We will contact you shortly.</p>";
    					}

                        // track email sending in session for anti spam checks
                        $_SESSION['sentemail'][]=time();

					}
				
				}

                $contact_form="<a name=\"contact_form\"></a>";
				if (isset($_SESSION['form']['contact_warning_green'])){$contact_form.=display_warnings($_SESSION['form']['contact_warning_green'],'green');}
                else{

  		            // display warnings
  		            if (isset($_SESSION['form']['contact_warning'])){$contact_form.=display_warnings($_SESSION['form']['contact_warning']);}

					$contact_form.="<form action=\"#contact_form\" method=\"post\" class=\"cms_form contact_form\" id=\"contactForm\">

                              <div class=\"form_row\"><label for=\"name\">Name:</label>
                              <input name=\"name\" id=\"name\" type=\"text\" maxlength=\"120\" value=\"".(isset($_POST['name']) ? $_POST['name'] : "")."\" /></div>

							  <div class=\"form_row\"><label for=\"phone\">Phone:</label>
							  <input name=\"phone\" id=\"phone\" type=\"text\" maxlength=\"120\"  value=\"".(isset($_POST['phone']) ? $_POST['phone'] : "")."\" /></div>

							  <div class=\"form_row\"><label for=\"email\">Email:</label>
							  <input name=\"email\" id=\"email\" type=\"email\" maxlength=\"120\"  value=\"".(isset($_POST['email']) ? $_POST['email'] : "")."\" /></div>

							  <div class=\"form_row\"><label for=\"message\">Message:</label><textarea name=\"message\" id=\"message\">".(isset($_POST['message']) ? $_POST['message'] : "")."</textarea></div>";

                                // policy consent text and checkboxes
                              $policy_consent_txt="";

                            if ($cms_settings['gdpr']==1){$policy_consent_txt="<div style=\"margin: 5px\">By submitting this form you give <span style=\"font-weight: bold\">".cms_site_name."</span> consent to collect and store your details and to send email to the email address provided by you.</div>";}
                            elseif($cms_settings['gdpr']==2){$policy_consent_txt="<div style=\"margin: 5px\"><input type=\"checkbox\" id=\"gdpr_consent\" name=\"gdpr_consent\"".(isset($rvi_gdpr_consent) ? "checked=\"checked\"" : "")."> <label for=\"gdpr_consent\" class=\"contact_form_policy\" style=\"font-weight: normal\">I agree to allow <span style=\"font-weight: bold\">".cms_site_name."</span> to collect and store my details under <span style=\"font-weight: bold\">GPDR</span> guidelines and to send email to the email address I have provided.</label></div>";}

                            if ($cms_settings['newsletter_consent']>0){$policy_consent_txt.="<div style=\"margin: 5px\"><input type=\"checkbox\" id=\"newsletter_consent\" name=\"newsletter_consent\"".(isset($rvi_newsletter_consent) ? "checked=\"checked\"" : "")."> <label for=\"newsletter_consent\" class=\"contact_form_policy\" style=\"font-weight: normal\">I agree to receive newsletter emails periodically from <span style=\"font-weight: bold\">".cms_site_name."</span>.</label></div>";}

                            $policy_consent_txt.="<div style=\"margin: 5px\">View our <a href=\"".cms_url."?terms#privacy\" target=\"_blank\">privacy policy</a>.</label></div>";

                            if ($google_invisible_captcha_enable>0){
                                $contact_form.="<div class=\"form_row_footer\"><input type=\"hidden\" name=\"contact_form_submit\"><button class=\"g-recaptcha\" data-sitekey=\"".$google_invisible_captcha_sitekey."\" data-callback=\"submitCaptchaForm\" style=\"padding: 10px 20px 10px 20px\">Send</button></div>";
                            }
                            else{
    							$contact_form.="<div class=\"form_row_footer\"><div class=\"contact_form_policy\">".$policy_consent_txt."</div><button type=\"submit\" name=\"contact_form_submit\" class=\"btn\">".$txt['btn_send']."</button></div>";
                            }
						  $contact_form.='</form>';

				}

			?>
