<?php

    // ini_set("memory_limit","100M");
	// ini_set("max_execution_time","3600");

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}

    if (user_level('news')<1){
        $page_content['main'].="<h3>Access Restricted</h3><p>You do not have the required user permissions to view this page.</p>";
        return;
    }

	if ($news_details=get_item_details('news',$rvi_news)){

        if (isset($news_details['template'])){
            $page_template=$news_details['template'];
            // load config file from theme folder if it exists
            $template_config_fn=display_theme_dir.'config/'.$news_details['template'];
            if (file_exists($template_config_fn)){include($template_config_fn);}
        }

        // ensure links in content are using the active cms_protocol http:// or https://
        if (cms_protocol=='https://'){
            foreach ($news_details['content'] as $content_area_name => $value){
                $news_details['content'][$content_area_name]=str_replace('http://'.strip_url_protocol(cms_root_url),cms_root_url,$value);
                $news_details['content'][$content_area_name]=str_replace('http://'.strip_url_protocol(cms_url),cms_url,$value);
            }
        }
        else{
            foreach ($news_details['content'] as $content_area_name => $value){
                $news_details['content'][$content_area_name]=str_replace('https://'.strip_url_protocol(cms_root_url),cms_root_url,$value);
                $news_details['content'][$content_area_name]=str_replace('https://'.strip_url_protocol(cms_url),cms_url,$value);
            }
        }

        $page_content=$news_details['content'];
        $page_content['main']="";

        if ($news_details['status']<1){
            if (admin_level('news')<1){include(cms_root_dir.'includes/page_not_found.php');return;}
            else{$page_content['main'].="<div class=\"warning_box\">This article is currently set to Draft which means only admins can view it. To make this article puclic set it to Publish in the admin area.</div>";}
        }

        // show breadcrumbs
        $page_content['main'].=breadcrumbs($news_details);

		// check user access to news
		if (isset($news_details['user_group']) && admin_level('news')<1){
            $access_denied=1;
			foreach ($news_details['user_group'] as $user_group_id){
				if ($user_group_id==0){$access_denied=0;break;}
				if ($user_group_id==1 && isset($_SESSION['reg_user'])){$access_denied=0;break;}
                if ($user_group_id==2 && admin_level()>0){$access_denied=0;break;}
				if (isset($_SESSION['reg_user']['user_group'])){
					foreach($_SESSION['reg_user']['user_group'] as $customer_user_group){
						if ($customer_user_group==$user_group_id){$access_denied=0;break;}
					}
					if ($access_denied<1){break;}
				}
			}
            if ($access_denied>0){
    			$page_content['main'].="<h3>Access Restricted</h3><p>You do not have the required user permissions to view this page.</p>";
                return;
		    }
		}


		// page meta tags
        $page_meta.="<link rel=\"canonical\" href=\"".item_url('news',$rvi_news,$news_details['slug'])."\" />";
		if (isset($news_details['short_description']) && strlen($news_details['short_description'])>0){$page_meta.="<meta name=\"description\" content=\"".htmlentities($news_details['short_description'],ENT_COMPAT,'UTF-8')."\" />";}
		if (isset($news_details['keywords']) && strlen($news_details['keywords'])>0){$page_meta.="<meta name=\"keywords\" content=\"".htmlentities($news_details['keywords'],ENT_COMPAT,'UTF-8')."\" />";}

		// output news detail
		$page_title.=htmlentities($news_details['name'],ENT_COMPAT,'UTF-8');

		$page_content['main'].="<div class=\"news_detail\">";

        if ((isset($news_details['image']) && count($news_details['image'])>0) || (isset($news_details['youtube_video']) && $news_details['youtube_video']!="")){

            // ovrerride main image size for mobile display
            if (display_type=='mobile'){
    		    $main_image_size_x=424;
    		    $main_image_size_y=250;
            }
            else{
                $main_image_size_x=$cms_settings['img']['width_main'];
    		    $main_image_size_y=$cms_settings['img']['height_main'];
            }

            $news_path=sys_data_dir.'/news/'.$rvi_news.'/';

            $image_content="";
            if (isset($news_details['image']) && count($news_details['image'])>0){

                foreach ($news_details['image'] as $image_fn => $value){

                    if (!file_exists($news_path.$image_fn)){continue;}

                    $image_mod_time=filemtime($news_path.$image_fn);

                    // page meta for facebook og
                    if (!isset($og_image)){
                        $og_image=1;

                        // image size should be minimum recommended by fb
                        // 1200x628 recommended - 1200x630 - 600x315 min
                        $og_tn_size_x=1200;
                        $og_tn_size_y=628;
                        /*
                        // I do not know why I have this ratio  resize code - can't remember - createthumb handles ration resize anyway?
                        $image_size=getimagesize($news_path.$image_fn);
                        if ($image_size[0]>0 && $image_size[1]>0){
                        $ratio=1.0;
                        if ($image_size[1]<$image_size[0]){
                        $ratio=$image_size[0]/$image_size[1];
                        }
                        elseif ($image_size[0]<$image_size[1]){
                        $ratio=$image_size[1]/$image_size[0];
                        }
                        $og_tn_size_x=ceil($og_tn_size_x*$ratio);
                        $og_tn_size_y=ceil($og_tn_size_y*$ratio);
                        }
                        */

                        // check facebook sharing image exists and create one if it doesn't
                        $og_thumbnail_fn=$og_tn_size_x."x".$og_tn_size_y.'_'.$image_mod_time.'n'.$news_details['id'].'_'.safe_file_name($image_fn);
                        if (!file_exists(sys_image_dir.'/'.$og_thumbnail_fn) || filemtime(sys_image_dir.'/'.$og_thumbnail_fn)<=$image_mod_time){
                            createthumb($news_path.$image_fn,sys_image_dir.'/'.$og_thumbnail_fn,$og_tn_size_x,$og_tn_size_y,1,watermark_articles);
                        }

                        if (isset($og_thumbnail_fn)){

                            $image_size=getimagesize(sys_image_dir.'/'.$og_thumbnail_fn);

                            $og_data['image']=cms_image_url.$og_thumbnail_fn;
                            $og_data['image_width']=$image_size[0];
                            $og_data['image_height']=$image_size[1];
                        }

                    }

                    if (isset($value['assign']) && $value['assign']!='Default Gallery'){continue;}

    				// check if correct size image exists and create one if it doesn't
    				$thumbnail_fn=$main_image_size_x."x".$main_image_size_y.'_'.$image_mod_time.'n'.$news_details['id'].'_'.safe_file_name($image_fn);
    				if (!file_exists(sys_image_dir.'/'.$thumbnail_fn) || filemtime(sys_image_dir.'/'.$thumbnail_fn)<=$image_mod_time){
    					createthumb($news_path.$image_fn,sys_image_dir.'/'.$thumbnail_fn,$main_image_size_x,$main_image_size_y,1,watermark_articles);
    				}

                    if (!file_exists(sys_image_dir.'/'.$thumbnail_fn)){continue;}

                    // check if correct size main image exists and create one if it doesn't
                    $thumbnail_main_fn=$cms_settings['img']['width_main']."x".$cms_settings['img']['height_main'].'_'.$image_mod_time.'n'.$news_details['id'].'_'.safe_file_name($image_fn);
    				if (!file_exists(sys_image_dir.'/'.$thumbnail_main_fn) || filemtime(sys_image_dir.'/'.$thumbnail_main_fn)<=$image_mod_time){
    					createthumb($news_path.$image_fn,sys_image_dir.'/'.$thumbnail_main_fn,$cms_settings['img']['width_main'],$cms_settings['img']['height_main'],1,watermark_articles);
    				}

                    // check if correct size zoom-in image exists and create one if it doesn't
                    $thumbnail_zoom_fn=$cms_settings['img']['zoom_width_tn']."x".$cms_settings['img']['zoom_height_tn'].'_'.$image_mod_time.'n'.$news_details['id'].'_'.safe_file_name($image_fn);
    				if (!file_exists(sys_image_dir.'/'.$thumbnail_zoom_fn) || filemtime(sys_image_dir.'/'.$thumbnail_zoom_fn)<=$image_mod_time){
    					createthumb($news_path.$image_fn,sys_image_dir.'/'.$thumbnail_zoom_fn,$cms_settings['img']['zoom_width_tn'],$cms_settings['img']['zoom_height_tn'],1,watermark_articles);
    				}

    				// get size of thumbnail image
    				$image_size=getimagesize(sys_image_dir.'/'.$thumbnail_fn);

    				$link_title=$news_details['name'];
    				if (strlen($value['alt_tag'])>0 && $value['alt_tag']!=$news_details['name']){$link_title.=' - '.$value['alt_tag'];}

                    $image_content.="<a href=\"".cms_image_url.$thumbnail_main_fn."\"><img alt=\"".htmlentities($value['alt_tag'],ENT_COMPAT,'UTF-8')."\" src=\"".cms_image_url.$thumbnail_fn."\" data-big=\"".cms_image_url.$thumbnail_zoom_fn."\"/></a>\n";

            	}

            }

            if (!empty($image_content)){

        		// jquery galleria includes
                $jquery_required=1;
                $page_meta.="<style type=\"text/css\">.galleria{width: ".$main_image_size_x."px; height: ".$main_image_size_y."px}</style>";
                $page_end.="<script src=\"".cms_root_url."plugins/galleria_1_6_1/dist/galleria.min.js\"></script>
                <script>
                $(function() {
                    // Load the classic theme
                    Galleria.loadTheme('".cms_root_url."plugins/galleria_1_6_1/dist/themes/classic/galleria.classic.min.js');

                    // Initialize Galleria
                    Galleria.run('.galleria',{
                    debug: false,
                    showInfo: false,
                    lightbox: true,
                    wait: true"; // we need to set wait: true if gallery is hidden for example xara variants, needs to be visible to initialise properly without error

                    if (count($news_details['image'])<2){
                        $page_end.=",
                        showImagenav: false,
                        thumbnails: false";
                    }

                    $page_end.="});
                });
                </script>";

                // $image_content="<div class=\"galleria img_group\" style=\"width: ".$main_image_size_x."px\">".$image_content."</div>";
                $image_content="<div class=\"galleria img_group\">".$image_content."</div>";

            }

        }

        // display image content
        $left_margin='';
        if (isset($image_content)){
            $page_content['main'].=$image_content;
            if (display_type!='mobile'){$left_margin=' style=\"margin-left: '.($cms_settings['img']['width_main']+15).'px"';}
        }

        $page_content['main'].="<div class=\"main_content\"><h1>".htmlentities($news_details['name'],ENT_COMPAT,'UTF-8')."</h1>";

        // get article owner name
        if (isset($news_details['customer_id'])){
            $customer_details=get_item_details('customer',$news_details['customer_id']);
            $article_owner=$customer_details['name'];
        }else{$article_owner='Admin';}

        // calculate number of days since update
        /*
        // not using because of caching inaccurate today/yesterday text
        $modified_time_midnight=mktime(0, 0, 0, date('m',$news_details['date']), date('d',$news_details['date']), date('Y',$news_details['date']));
        $num_of_days=(time()-$modified_time_midnight)/86400;
        if ($num_of_days<1){$post_time='Today';}
        elseif ($num_of_days<2){$post_time='Yesterday';}
        else {$post_time=date('jS F Y',$news_details['date']);}
        $page_content['main'].="<div class=\"news_detail_date\">".$post_time." by ".$article_owner."</div>";
        */

        // display article date and author
        $page_content['main'].="<div class=\"news_detail_date\">".date('jS F Y',$news_details['date'])." by ".$article_owner."</div>";

		$page_content['main'].="<div class=\"news_detail_content\">".$news_details['content']['main']."</div>";
        // facebook og code
        $og_data['title']=$news_details['name'];
        if (isset($news_details['short_description']) && $news_details['short_description']!=''){$og_data['description']=htmlentities($news_details['short_description'],ENT_COMPAT,'UTF-8');}
        $og_data['url']=item_url('news',$rvi_news,$news_details['slug']);

		$page_content['main'].="</div>"; // end of main_content div

        $comment_content="";
        $comment_form="";

        // display comments
        if ($news_details['comments_visible']>0){

            $comment_count=0;

            $search_comments['article_id']=$news_details['id'];

            if($comments=get_items('messages',null,1,null,null,$search_comments)){

                $comment_count=count($comments);

                for ($comment_num=0; $comment_num<$comment_count; $comment_num++){

                    if ($comment_details=get_item_details('message',$comments[$comment_num]['id'])){


                        $comment_content.='<div class="comment">';
                        if ($comment_details_owner=get_item_details('customer',$comment_details['customer_id'])){
                            if (isset($cms_settings['users']['profile_pages']) && $cms_settings['users']['profile_pages']>0){
                                $comment_content.='<div class="comment_by"><a href="'.cms_url.'?profile='.$comment_details_owner['id'].'" class="comment_link">'.$comment_details_owner['name'].'</a> <i>says</i>:</div>';
                            }
                            else{
                                if (isset($comment_details_owner['website']) && strlen($comment_details_owner['website'])>2){
                                    $comment_content.='<div class="comment_by"><a href="'.$comment_details_owner['website'].'" class="comment_link" target="_blank">'.$comment_details_owner['name'].'</a> <i>says</i>:</div>';
                                }
                                else{
                                    $comment_content.='<div class="comment_by"><a href="#" class="comment_link">'.$comment_details_owner['name'].'</a> <i>says</i>:</div>';
                                }

                            }
                        }
                        $timestamp=substr($comment_details['id'],0,-3);
                        $date=date("M d,Y",$timestamp);
                        $time=date("H:i",$timestamp);
                        $comment_content.='<div class="comment_date">'.$date.' at '.$time.'</div>';
                        $comment_content.=$comment_details['message'];
                        $comment_content.='</div>';

                    }

                }

            }



        }


		// display comment form
		if ($news_details['comment_form_enabled']>0){

            // check user access to comment form
    		if (isset($news_details["commenting_user_group"])){
    			foreach ($news_details["commenting_user_group"] as $user_group_id){
    				if ($user_group_id=="0" || isset($_SESSION['Logged_In_Admin'])){break;}
    				elseif($user_group_id=="1" && isset($_SESSION['reg_user'])){break;}
    				elseif(isset($_SESSION['reg_user']['user_group'])){
    					foreach($_SESSION['reg_user']['user_group'] as $customer_user_group){
    						if ($customer_user_group==$user_group_id){$omit=0;break;}
    					}
    					if ($omit<1){break;}
    				}
    				else{$access_comment_form_denied=TRUE;}
    			}
    		}

            if (isset($access_comment_form_denied)){
                if (in_array(1,$news_details["commenting_user_group"]) && (count($news_details["commenting_user_group"])<2 || (count($news_details["commenting_user_group"])<3 && in_array(0,$news_details["commenting_user_group"])))){$page_content['main'].="<hr /><h3>Please login to leave a comment</h3>";}
            }
            else{

                if (isset($rvi_remember_me)){$_SESSION['form']['login']['remember_me']=1;}

                if (isset($rvi_password) && strlen($rvi_password)>0){

                    $_SESSION['form']['login']['password']=$rvi_password; // think about removing this from session or using $_SESSION['form']['login']['password']

                    if (strlen($rvi_password)<4){$_SESSION['form']['news_detail']['warning'][]="Your password must be at least 4 characters long";}
                    else{
                        // attempt to login user if email password match found
                        $login_user=login_validate($rvi_email,$rvi_password);
                        if ($login_user['user_id']<1){sleep(2);} // anti-brute-force measure on failed login (or new user?)
                    }

                }


/*                    if (isset($_SESSION['reg_user']) && isset($news_details['customer_id']) && $_SESSION['reg_user']['id']==$news_details['customer_id']){
                    $_SESSION['form']['news_detail']['warning_green'][]='This article was submitted under your account. To update this article <a href="'.cms_url.'?myaccount&amp;modify_listing='.$listing_details['id'].'">click here</a>.';
                }*/

                if (isset($rvi_submit_enquiry)){

    				require_once(cms_root_dir.'scripts/emailval.php');

                    if (isset($rvi_name)){$_SESSION['form']['news_detail']['name']=sanitize_text_input($rvi_name);}
                    if (isset($rvi_email)){$_SESSION['form']['news_detail']['email']=sanitize_text_input($rvi_email);}
                    if (isset($rvi_website)){$_SESSION['form']['news_detail']['website']=sanitize_text_input($rvi_website);}
                    $_SESSION['blog_comment'][$news_details['id']]=sanitize_text_input($rvi_enquiry_message);

    				if (!isset($_SESSION['reg_user']) && strlen($rvi_name)<2){$_SESSION['form']['news_detail']['warning'][]='Please enter your name.';}
                    // check email address if not logged in
                    if (!isset($_SESSION['reg_user'])){
                    	require_once(cms_root_dir.'scripts/emailval.php');
                    	if (strlen($rvi_email)<4 || MailVal($rvi_email,2)){$_SESSION['form']['news_detail']['warning'][]='Please enter your email address.';}
                        elseif (email_registered($rvi_email)){$_SESSION['form']['news_detail']['warning']=array($txt['Warning_email_registered']);}
                	}

                    if (!isset($_SESSION['reg_user']) && isset($cms_settings['users']['security_answer']) && $cms_settings['users']['security_answer']!=""){
                        $rvi_security_answer=trim(strtolower($rvi_security_answer));
                        if ($rvi_security_answer!=trim(strtolower($cms_settings['users']['security_answer']))){$_SESSION['form']['news_detail']['warning'][]='Please answer the anti-spam security question correctly.';}
                    }

    				if (strlen($rvi_enquiry_message)<10){$_SESSION['form']['news_detail']['warning'][]="Your comment is too short.";}
                    else{
                        // check for spam in message
            			$spam_words=array('cialis','viagra','xanax','tramadol','replicawatch','freeringtone','[/url]','lesbian','porn','penis');
            			foreach ($spam_words as $spam_word){
            				if (strpos(strtolower($rvi_enquiry_message),$spam_word)!==FALSE){$_SESSION['form']['news_detail']['warning'][]='Message contains spam filtered words. Please remove the word &quot;'.$spam_word.'&quot;.';break;}
            			}
                        $swear_words=array('fuck');
            			foreach ($swear_words as $swear_word){
            				if (strpos(strtolower($rvi_enquiry_message),$swear_word)!==FALSE){$_SESSION['form']['news_detail']['warning'][]='Message contains offensive words. Please edit your message.';break;}
            			}
                        $limit_words=array('@','http','www','.com','.net','.biz','.info','.org','.ru');
                        foreach ($limit_words as $limit_word){
            			    if (substr_count($rvi_enquiry_message,$limit_word)>2){$_SESSION['form']['news_detail']['warning'][]='Spam filter found too many &quot;'.$limit_word.'&quot; in message. Please edit your message.';break;}
                        }
                    }

    				if (!isset($_SESSION['form']['news_detail']['warning'])){

                        $message_details['timestamp']=time();
                        $message_details['id']=$message_details['timestamp'].rand(100,999);
                        $message_details['item_type']='message';
                        $message_details['status']=0; // 0=awaiting moderation, 1=approved, 2=spam
                        $message_details['message']=$rvi_enquiry_message;
                        $message_details['article_id']=$news_details['id'];
                        $message_details['recipient_id']=0;
                        $message_details['ip_address']=$_SERVER['REMOTE_ADDR'];
                        if (isset($_SESSION['reg_user']['id'])){
                            $message_details['customer_id']=$_SESSION['reg_user']['id'];
                        }else{
                          $message_details['customer_id']=$message_details['timestamp'].rand(100,999);
                        }
                        if (isset($rvi_rating)){$message_details['rating']=$rvi_rating;}else{$message_details['rating']=0;}

                        save_item_details($message_details);
                        update_item_list_file('messages',array($message_details['id']),'add');

                          // save unverified customer details if not logged in
            			if (!isset($_SESSION['reg_user']['id'])){
                            // save customer details
                            $customer_details['item_type']='customer';
                			$customer_details['id']=$message_details['customer_id'];
                            $customer_details['verified']='0';

                            // generate a random password
                            if (isset($_SESSION['form']['login']['password']) && strlen($_SESSION['form']['login']['password'])>4){$password=$_SESSION['form']['login']['password'];}else{$password=generate_password();}
                            $customer_details['password']=encrypt_password($password,$customer_details['id']);

                			$customer_details['status']='1';
                			$customer_details['registered_timestamp']=$message_details['timestamp'];
                			if (isset($_SESSION['referrer'])){$customer_details['referrer']=$_SESSION['referrer'];}
                			$customer_details['name']=$_SESSION['form']['news_detail']['name'];
                			$customer_details['email']=$_SESSION['form']['news_detail']['email'];
                			$customer_details['newsletter_subscription']='yes';
                            $customer_details['phone']='';
                            $customer_details['dob_day']='---';
                            $customer_details['dob_month']='---';
                            $customer_details['dob_year']='---';
                            $customer_details['address']='';
                            $customer_details['address_2']='';
                            $customer_details['city']='';
                            $customer_details['postcode']='';
                            $customer_details['county']='';
                            $customer_details['country']='---';

                            if (isset($_SESSION['form']['news_detail']['website'])){
                                $customer_details['website']=sanitize_text_input($_SESSION['form']['news_detail']['website']);
                                if (strlen($customer_details['website'])<6){$customer_details['website']='';}
                                elseif (strtolower(substr($customer_details['website'],0,4))!='http'){$customer_details['website']='http://'.$customer_details['website'];}
                            }

            				save_item_details($customer_details);
                            update_item_list_file('customers',array($customer_details['id']),'add');

                            update_log('New user account registered - '.$customer_details['id'].' - via article comment');

                            // log new user in (still unvereified until user logs in with emailed password)
                            if (isset($_SESSION['form']['login']['remember_me'])){   // why only login when rember me checked? might remove this
                                login_user($customer_details);
                            }

                            // send customer registration email
                            // email customer order confirmation with payment link
            			    require_once(cms_root_dir.'plugins/PHPMailer/class.phpmailer.php');

            			    $mail = new PHPMailer();

                            // send mail via smtp if set in config file
                            if (defined('smtp_host')){
                                $mail->IsSMTP(); // send via SMTP
                                $mail->SMTPAuth = true; // turn on SMTP authentication
                                $mail->SMTPSecure = 'ssl';
                                $mail->Username = smtp_username; // SMTP username
                                $mail->Password = smtp_password; // SMTP password
                                $mail->Host       = smtp_host; // SMTP server
                                $mail->Port       = smtp_port; // SMTP server
                            }

            				// send confirmation email to user
            				$mail->From = $cms_settings['config']['site_email'];
            				$mail->FromName = cms_site_name;
            				$mail->AddAddress($rvi_email);

            				$mail->Subject = cms_site_name.' - New Account Registration';
                            $mail->Body    = "Hi $rvi_name,\n\nThank you for registering with ".cms_site_name." - Your new login password is ".$password."\n\nClick on the link below to login.\n\n".user_login_link($customer_details)."\n\nThis is an automated email; if you received it in error, no action is required.\n\n".cms_site_name."\n".cms_site_url;
                            $mail->IsHTML(FALSE);

            				if(!$mail->Send()){exit;}

                        }

                        if (isset($_SESSION['blog_comment'][$news_details['id']])){unset($_SESSION['blog_comment'][$news_details['id']]);}
    					$enquiry_submitted=1;
                        $_SESSION['form']['news_detail']['warning_green'][]='<h2>Thank You</h2><p>Your comment has been submitted.';

                        update_admin_notify_log('New user comment');

    				}
                }


    			if (!isset($enquiry_submitted)){

	                // populate fields if user is logged in
                	if (!isset($_SESSION['form']['news_detail']['name']) || $_SESSION['form']['news_detail']['name']==''){
                        if (isset($customer_details['name'])){$_SESSION['form']['news_detail']['name']=$customer_details['name'];}else{$_SESSION['form']['news_detail']['name']='';}
                    }
                    if (!isset($_SESSION['form']['news_detail']['email'])){
                        if (isset($customer_details['email'])){$_SESSION['form']['news_detail']['email']=$customer_details['email'];}else{$_SESSION['form']['news_detail']['email']='';}
                    }
                	if (!isset($_SESSION['form']['news_detail']['website'])){
                        if (isset($customer_details['website'])){$_SESSION['form']['news_detail']['website']=$customer_details['website'];}else{$_SESSION['form']['news_detail']['website']='';}
                    }

    				if (!isset($_SESSION['blog_comment'][$news_details['id']])){$_SESSION['blog_comment'][$news_details['id']]='';}



                    $comment_form.="<hr /><form action=\"#comment_form\" method=\"post\" class=\"comment_form\"><fieldset>
                    <legend>Leave a comment</legend>";
                    // if (!isset($_SESSION['reg_user'])){$comment_form.="<p class=\"small_note\">Use the form below to leave a comment.</p>";}

                    $comment_form.="<table border=\"0\" cellpadding=\"2\" cellspacing=\"0\">";

                        if (isset($_SESSION['reg_user'])){
                            $comment_form.="<tr><td colspan=\"2\" class=\"small_note\">Welcome back ".stripslashes(short_name($_SESSION['reg_user']['name']))." (<a href=\"".cms_url."?logout\">logout</a>). Use the text area below to leave a comment.</td></tr>";
                        }
                        else{
                            $comment_form.="<tr><td width=\"80\"><b>Name: </b></td><td><input name=\"name\" type=\"text\" maxlength=\"128\" value=\"".stripslashes($_SESSION['form']['news_detail']['name'])."\" /></td></tr>
                            <tr><td><b>Email: </b></td><td><input type=\"email\" name=\"email\" maxlength=\"128\" value=\"".stripslashes($_SESSION['form']['news_detail']['email'])."\" /> <span class=\"small_note\">(not published)</span></td></tr>
                            <tr><td><b>Website: </b></td><td><input name=\"website\" type=\"text\" maxlength=\"128\" value=\"".stripslashes($_SESSION['form']['news_detail']['website'])."\" /></td></tr>";
                        }

                        if (!isset($_SESSION['reg_user'])){
                            $comment_form.="<tr>
                              <td colspan=\"2\"><hr /><p class=\"small_note\"><b>New user:</b> Enter a password below (min 4 characters) or leave blank and one will be generated for you.<br />
                              <b>Registered user:</b> Login with your password below. <a href=\"".cms_url."?forgot_password\">Forgot Password</a></p></td>
                            </tr>
                            <tr>
                              <td valign=\"top\"><b>Password: </b></td><td><input type=\"password\" name=\"password\" value=\"".(isset($_SESSION['form']['login']['password']) ? $_SESSION['form']['login']['password'] : '')."\" /></td>
                            </tr>
                            <tr><td>&nbsp;</td><td><label><input type=\"checkbox\" name=\"remember_me\"".(isset($_SESSION['form']['login']['remember_me']) ? ' checked="checked"' : '')." /> Remember Me</label></td></tr>

                            ";

                            if (isset($cms_settings['users']['security_question']) && $cms_settings['users']['security_question']!="" && $cms_settings['users']['security_answer']!=""){

                            $comment_form.="<tr>
                              <td colspan=\"2\"><hr /><p class=\"small_note\">Answer the question below to verify you're not a spam-bot.</p>
                              <span class=\"small_note\"><b>".$cms_settings['users']['security_question']."</b> <input type=\"text\" name=\"security_answer\" value=\"".(isset($rvi_security_answer) ? $rvi_security_answer : "")."\" /></td>
                            </tr>";

                            }

                            $comment_form.="<tr><td  colspan=\"2\"><hr /></td></tr>";
                        }

                        $comment_form.="<tr><td colspan=\"2\"><b>Your Comment:</b><br /><textarea name=\"enquiry_message\" rows=\"5\" class=\"comment_box\">".$_SESSION['blog_comment'][$news_details['id']]."</textarea></td></tr>
        				<tr><td colspan=\"2\" align=\"right\"><input type=\"submit\" value=\"Post Comment\" name=\"submit_enquiry\" class=\"btn\" /></td></tr>
                        </table></fieldset></form>";

    			}

            }

		}

        // displaying comments and comment form
        if ($comment_content!="" || $comment_form!=""){

            $page_content['main'].="<div style=\"flex-basis: 100%\">"; // start of comment section div

            if ($comment_content!=""){
                $page_content['main'].='<hr /><h3>'.$comment_count.' Responses to '.$news_details['name'].'</h3>';
                $page_content['main'].=$comment_content;
            }

            if ($comment_form!=""){$page_content['main'].="<a name=\"comment_form\"></a>";}

            // display warnings
            if (isset($_SESSION['form']['news_detail']['warning'])){$page_content['main'].=display_warnings($_SESSION['form']['news_detail']['warning']);}
            elseif (isset($_SESSION['form']['news_detail']['warning_green'])){$page_content['main'].=display_warnings($_SESSION['form']['news_detail']['warning_green'],'green');}

            $page_content['main'].=$comment_form."</div>"; // end of comment section div
        }



        $page_content['main'].="</div>"; // end of news detail div

  		// display related news
  		if (isset($news_details['related_article'])){
  			$category_details=get_category_details(5);
  			$page_output=display_category($category_details,1,null,$news_details['related_article']);
  			$page_content['main'].="<hr />".$page_output['content']['main'];
  		}

  		// add to recently viewed items - don't think we really need this for articles (products only?)
        /*
  		if (!isset($_SESSION['recently_viewed_news'][$rvi_news])){$_SESSION['recently_viewed_news'][$rvi_news]['priority']=1;}
  		else{$_SESSION['recently_viewed_news'][$rvi_news]['priority']++;}
        */

	}else{include(cms_root_dir.'includes/page_not_found.php');}

?>
