<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number") || user_level('products')<1){exit();}

	$product_id=$rvi_add_to_cart;
	if (isset($rvi_product_details)){$product_details=$rvi_product_details;}else{$product_details=get_item_details('product',$product_id);}

	if (!is_array($product_details) || $product_details['status']<1){
        return;
    }

    // check nesecary product options are selected
    if (isset($product_details['option'])){
        foreach ($product_details['option'] as $option_name => $value2){
            // if no product option is selected select first option value as default
            if (!isset($rvi_product_option[$option_name])){$rvi_product_option[$option_name]=key($value2);}
        }
    }

		// check if note or file upload are required before adding to cart - note might want to use $_SESSION['form']['add_to_cart']['warning'] instead and display these on product_detail.php etc.
		if (isset($product_details['note_form_enabled']) && $product_details['note_form_enabled']==2 && (!isset($rvi_customer_note) || strlen($rvi_customer_note)<1)){$_SESSION['form']['product_detail']['warning'][]="Please enter required text in the text box provided";}
		if (isset($product_details['file_upload_enabled']) && $product_details['file_upload_enabled']==2 && !is_uploaded_file($_FILES['uploaded_file']['tmp_name'])){$_SESSION['form']['product_detail']['warning'][]="A file must be uploaded to add to cart";}
		if (isset($_SESSION['form']['product_detail']['warning'])){
            // redirect after form submit so browser back and refresh work without browser resend form data warning
            header('HTTP/1.1 303 See Other');
            header("Location: ".item_url('product',$product_details['id'],$product_details['slug']));
            exit();
        }
		else{
            $product_price=$product_details['price'];
			$options_text='';
			// process selected product options if any
			if (isset($rvi_product_option)){

				foreach ($rvi_product_option as $option => $value){

					// product options string for generating product option identifier
					$options_text=$options_text.$option.': '.$value.'<br />';

					// find option matches and apply option modifiers
                    $option_exists=0;
					foreach ($product_details['option'] as $option_name => $value2){
						if ($option_name==$option){
                            if (count($value2)==1 && key($value2)==''){$option_exists=1;break;}
							foreach ($product_details['option'][$option_name] as $option_value => $value3){
								if ($option_value==$value){
                                    $option_exists=1;
                                    // adjust price based on selected product option
                                    if ($product_details['option'][$option_name][$option_value]['price_mod_value']!=0){
                                        // if b2b is enabled treat product options as excl tax so ensure we add tax amount onto them here for order price
                                        if ($cms_settings['b2b']>0 && $product_details['option'][$option_name][$option_value]['price_mod_value']>0){
                                            $product_details['option'][$option_name][$option_value]['price_mod_value']=$product_details['option'][$option_name][$option_value]['price_mod_value']*(($product_details['tax_rate']/100)+1);
                                        }
                                        if ($product_details['option'][$option_name][$option_value]['price_mod']==0){
                                            $product_price=$product_price+$product_details['option'][$option_name][$option_value]['price_mod_value'];
                                        }else{$product_price=$product_details['option'][$option_name][$option_value]['price_mod_value'];}
                                    }
                                    // adjust weight based on selected product option
                                    if ($product_details['option'][$option_name][$option_value]['weight_mod_value']!=0){
                                        if ($product_details['option'][$option_name][$option_value]['weight_mod']==0){
                                            $product_details['weight']=$product_details['weight']+$product_details['option'][$option_name][$option_value]['weight_mod_value'];
                                        }else{$product_details['weight']=$product_details['option'][$option_name][$option_value]['weight_mod_value'];}
                                    }
                                    // adjust volume based on selected product option
                                    if ($product_details['option'][$option_name][$option_value]['volume_mod_value']!=0){
                                        if ($product_details['option'][$option_name][$option_value]['volume_mod']==0){
                                            $product_details['volume']=$product_details['volume']+$product_details['option'][$option_name][$option_value]['volume_mod_value'];
                                        }else{$product_details['volume']=$product_details['option'][$option_name][$option_value]['volume_mod_value'];}
                                    }
								}
							}
						}
					}
                    if ($option_exists<1){
                        return;
                    }
				}

			}
			
			if (isset($rvi_customer_note)){
				$rvi_customer_note=sanitize_text_input($rvi_customer_note);
			}
			else{$rvi_customer_note='';}
			if (isset($_FILES['uploaded_file']) && is_uploaded_file($_FILES['uploaded_file']['tmp_name'])){
				if ($_FILES['uploaded_file']['size']>2097152 || ($_FILES['uploaded_file']['type']!="image/pjpeg" && $_FILES['uploaded_file']['type']!="image/jpeg")){$_SESSION['form']['product_detail']['warning'][]="Image upload error";}
				$uploaded_filename=$_FILES['uploaded_file']['name'];
			}else{$uploaded_filename='';}

            $product_option_identifier=$product_id.'|'.$options_text.'|'.$rvi_customer_note.'|'.$uploaded_filename;
			$product_option_identifier=base64_encode($product_option_identifier);
			
			if (isset($rvi_qty)){$add_qty=$rvi_qty;}else{$add_qty=1;}
            if ($add_qty<0){$add_qty=0;}

			if (!isset($_SESSION['form']['product_detail']['warning'])){
				// add product to cart
				if (!isset($_SESSION['cart']['products'][$product_option_identifier])){

                    // remove unesecary product data for checkout/order
                    if (isset($product_details['created_time'])){unset($product_details['created_time']);}
                    if (isset($product_details['modified_time'])){unset($product_details['modified_time']);}
                    if (isset($product_details['item_file_version'])){unset($product_details['item_file_version']);}
                    if (isset($product_details['slug'])){unset($product_details['slug']);}
                    if (isset($product_details['short_description'])){unset($product_details['short_description']);}
                    if (isset($product_details['keywords'])){unset($product_details['keywords']);}
                    if (isset($product_details['content'])){unset($product_details['content']);}
                    if (isset($product_details['youtube_video'])){unset($product_details['youtube_video']);}
                    if (isset($product_details['template'])){unset($product_details['template']);}
                    if (isset($product_details['enquiry_form_enabled'])){unset($product_details['enquiry_form_enabled']);}

                    // copy all product details into cart product
                    $_SESSION['cart']['products'][$product_option_identifier]=$product_details;
                    // populate cart product with additional data
					$_SESSION['cart']['products'][$product_option_identifier]['order_price']=$product_price;
                    if (isset($rvi_product_option)){
    				    foreach ($rvi_product_option as $option => $value){
                            $_SESSION['cart']['products'][$product_option_identifier]['option'][$option]=$value;
                        }
                    }
                    if ($add_qty<1){$add_qty=1;}
					$_SESSION['cart']['products'][$product_option_identifier]['order_qty']=$add_qty;
/*
                    if (isset($product_details['subscription']) && $product_details['subscription']>0){
                        $_SESSION['cart']['products'][$product_option_identifier]['subscription']=$product_details['subscription'];
                        if (isset($product_details['subscription_user_group'])){$_SESSION['cart']['products'][$product_option_identifier]['subscription_user_group']=$product_details['subscription_user_group'];}
                    }
*/
                    // keep the filename for the main image only
                    if (isset($_SESSION['cart']['products'][$product_option_identifier]['image'])){
						foreach($_SESSION['cart']['products'][$product_option_identifier]['image'] as $image_fn => $value){
							$_SESSION['cart']['products'][$product_option_identifier]['image_file']=$image_fn;
							break;
						}
                        unset($_SESSION['cart']['products'][$product_option_identifier]['image']);
					}

					$_SESSION['cart']['products'][$product_option_identifier]['customer_note']=$rvi_customer_note;
					if (isset($_FILES['uploaded_file']) && is_uploaded_file($_FILES['uploaded_file']['tmp_name'])){
						move_uploaded_file($_FILES['uploaded_file']['tmp_name'],sys_data_dir.'/uploads/'.$product_id.'_'.$_FILES['uploaded_file']['name']);
						$_SESSION['cart']['products'][$product_option_identifier]['uploaded_file']=$_FILES['uploaded_file']['name'];
					}

				}else{
                    // simply increase order qty if product is already in cart
					$_SESSION['cart']['products'][$product_option_identifier]['order_qty']=$_SESSION['cart']['products'][$product_option_identifier]['order_qty']+$add_qty;
				}
				// update order sub total
				$_SESSION['cart']['subtotal']=get_order_subtotal();
                //if (isset($_SESSION['checkout']['coupons'])){unset($_SESSION['checkout']['coupons']);}
				
				// add to recently viewed items
				if (!isset($_SESSION['recently_viewed_products'][$product_id])){$_SESSION['recently_viewed_products'][$product_id]['priority']=1;}
				else{$_SESSION['recently_viewed_products'][$product_id]['priority']++;}

                // auto-apply coupons
                include_once(cms_root_dir.'includes/shop/coupon_auto_apply.php');

                // if add to cart is run via ajax exit now
                if (isset($rvi_ajax)){exit;}

                $skip_cart=1;
                foreach($_SESSION['cart']['products'] as $product_option_id => $product){
                    if ($product['behaviour']=='Add to Cart'){$skip_cart=0;break;}
                }
                if ($skip_cart>0){
                    $_SESSION['order_stage']='checkout';
                    // redirect after form submit so browser back and refresh work without browser resend form data warning
                    header('HTTP/1.1 303 See Other');
                    header("Location: ".cms_url."?order_stage=checkout");
                    exit();
                }

                // redirect after form submit so browser back and refresh work without browser resend form data warning
                header('HTTP/1.1 303 See Other');
                header("Location: ".cms_url."?cart");
                exit();

			}else{
                // redirect after form submit so browser back and refresh work without browser resend form data warning
                header('HTTP/1.1 303 See Other');
                header("Location: ".cms_url."?product=".$product_id);
                exit();

            }
		}


	
?>
