<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}

    // auto-apply coupons
    include_once(cms_root_dir.'includes/shop/coupon_auto_apply.php');

	// set page title
	$page_title.=cms_site_name." - Shopping Cart";

		// update cart quantities
		if (isset($rvi_cart_qty)){
			foreach($_SESSION['cart']['products'] as $product_option_id => $product){
				// remove item from cart if qty less than 1
				if ($rvi_cart_qty[$product_option_id]<1){unset($_SESSION['cart']['products'][$product_option_id]);}
				else{$_SESSION['cart']['products'][$product_option_id]['order_qty']=$rvi_cart_qty[$product_option_id];}
			}
			// update order sub total
			$_SESSION['cart']['subtotal']=get_order_subtotal();
            if (isset($_SESSION['checkout']['coupons'])){unset($_SESSION['checkout']['coupons']);}
            if (isset($_SESSION['checkout']['discount'])){unset($_SESSION['checkout']['discount']);}

		
    		// remove any items that are selected to be removed
    		if (isset($rvi_remove_item)){
    			foreach($rvi_remove_item as $product_option_id => $value){
    				//if ($value="on"){unset($_SESSION['cart']['products'][$product_option_id]);}
                    unset($_SESSION['cart']['products'][$product_option_id]);
    			}
    			// update order sub total
    			$_SESSION['cart']['subtotal']=get_order_subtotal();
                // these are unset above do we need to repeat here? should discount be set to 0 instead of unset?
                if (isset($_SESSION['checkout']['coupons'])){unset($_SESSION['checkout']['coupons']);}
                if (isset($_SESSION['checkout']['discount'])){unset($_SESSION['checkout']['discount']);}
    		}

            // redirect after form submit so browser back and refresh work without browser resend form data warning
            header('HTTP/1.1 303 See Other');
            header("Location: ".cms_url."?cart");
            exit();
        }


		// display shopping cart
		if (isset($_SESSION['cart']['products']) && count($_SESSION['cart']['products'])>0){

			$tn_size_x=110;
			$tn_size_y=110;

			/*$cart_page_content="<form name=\"shopping_cart\" method=\"post\" action=\"".cms_url."?cart\"><table align=\"center\" id=\"shopping_cart\" class=\"cms_table\">
			<thead><tr>".(display_type!='mobile' ? "<th style=\"width: 90px\">Remove</th><th>&nbsp;</th>" : "")."<th>Product</th><th style=\"width: 90px; text-align: center\">Qty</th><th align=\"right\">Total</th></tr></thead>
            <tbody>";*/
            			$cart_page_content="<form name=\"shopping_cart\" method=\"post\" action=\"".cms_url."?cart\"><table align=\"center\" id=\"shopping_cart\" class=\"cms_table\">
			<thead><tr>".(display_type!='mobile' ? "<th>&nbsp;</th>" : "")."<th>".$txt['invoice_items_heading']."</th><th style=\"width: 90px; text-align: center\">Qty</th><th align=\"right\">Total</th></tr></thead>
            <tbody>";
			 $alternate_rowcol='';
             $subtotal=0;
			foreach($_SESSION['cart']['products'] as $product_option_id => $product){

				$product_path=sys_data_dir.'/products/'.$product['id'].'/';

				// if product file no longer exists remove from cart
				if ($product['id']>0 && !file_exists($product_path."data.php") && !file_exists($product_path."details.php")){unset($_SESSION['cart']['products'][$product_option_id]);continue;}

				if (display_type!='mobile' && isset($product['image_file'])){

                    if (isset($product['listing_id'])){

        			    // check if correct size image exists and create one if it doesn't
    					$thumbnail_fn=$tn_size_x."x".$tn_size_y.'_l'.$product['listing_id'].'_'.safe_file_name($product['image_file']);

      					if (!file_exists(sys_image_dir.'/'.$thumbnail_fn)){
                            $listing_path=sys_data_dir.'/listings/'.$product['listing_id'].'/';
                            if (file_exists($listing_path.$product['image_file'])){createthumb($listing_path.$product['image_file'],sys_image_dir.'/'.$thumbnail_fn,$tn_size_x,$tn_size_y,1);}
      					}

                    }
                    else{

    					// check if correct size image exists and create one if it doesn't
    					$thumbnail_fn=$tn_size_x."x".$tn_size_y.'_p'.$product['id'].'_'.safe_file_name($product['image_file']);

      					if (!file_exists(sys_image_dir.'/'.$thumbnail_fn)){
                            if (file_exists($product_path.$product['image_file'])){createthumb($product_path.$product['image_file'],sys_image_dir.'/'.$thumbnail_fn,$tn_size_x,$tn_size_y,1);}
      					}

                    }
					
					// get size of thumbnail image
					$image_size=getimagesize(sys_image_dir.'/'.$thumbnail_fn);
	
				}

				if (strlen($product['code'])>0){$product_code="<span class=\"product_code\">(".$product['code'].")</span><br />";}else{$product_code='';}

				$cart_page_content.="<tr".$alternate_rowcol.">";
                if (display_type!='mobile'){
                    //$cart_page_content.="<td align=\"center\"><input type=\"checkbox\" name=\"remove_item[$product_option_id]\"></td>";
                    $cart_page_content.="<td width=\"$tn_size_x\" align=\"center\" style=\"background-color: #ffffff\">";
                }
				if (isset($product['image_file']) && isset($thumbnail_fn)){
                    if (isset($product['listing_id']) || isset($product['subscription_id'])){$cart_page_content.="<img src=\"".cms_image_url.$thumbnail_fn."\" width=\"".$image_size[0]."\" height=\"".$image_size[1]."\" alt=\"".$product['name']."\" border=\"0\">";}
                    else{$cart_page_content.="<a href=\"".item_url('product',$product['id'])."\"><img src=\"".cms_image_url.$thumbnail_fn."\" width=\"".$image_size[0]."\" height=\"".$image_size[1]."\" alt=\"".$product['name']."\" border=\"0\"></a>";}
                }
				if (display_type!='mobile'){$cart_page_content.="</td>";}
                $cart_page_content.="<td width=\"300\">".$product_code;
                if (isset($product['listing_id']) || isset($product['subscription_id'])){$cart_page_content.=$product['name'];}
                else{$cart_page_content.="<a href=\"".item_url('product',$product['id'])."\">".$product['name']."</a>";}

                if (isset($product['option'])){
                    $cart_page_content.="<div style=\"font-size: 12px;\">";
                    foreach ($product['option'] as $option => $value){
                        $cart_page_content.=$option.': '.$value.'<br />';
                    }
                    $cart_page_content.="</div>";
                }

				if (strlen($product['customer_note'])>0){$cart_page_content.="<div class=\"customer_note\"><b>Instructions/Notes:</b><br />".$product['customer_note']."</div>";}
				if (isset($product['uploaded_file'])){$cart_page_content.="<div class=\"customer_note\"><b>File:</b><br />".$product['uploaded_file']."</div>";}
                // if (isset($product['subscription_id'])){$cart_page_content.='<div class=\"customer_note\">Subscription Ref: '.$product['subscription_id'].'</div>';}
                // if (isset($product['listing_id'])){$cart_page_content.='<div class=\"customer_note\">Listing Ref: '.$product['listing_id'].'</div>';}

                // remove item button
                $cart_page_content.="<div class=\"sc_product_controls\"><input type=\"submit\" name=\"remove_item[$product_option_id]\" value=\"Remove\"></div>";

                // displaying product order price
                $total_product_order_price=$product['order_price']*$product['order_qty'];
                if ($cms_settings['b2b']>0){$total_product_order_price=$total_product_order_price/(($product['tax_rate']/100)+1);}
                $subtotal=$subtotal+$total_product_order_price;

				$cart_page_content.="</td><td width=\"50\" align=\"center\"><input type=\"text\" name=\"cart_qty[$product_option_id]\" value=\"".$product['order_qty']."\" class=\"qty\"></td><td width=\"100\" align=\"right\">".currency_symbol.number_format($total_product_order_price,2)."</td></tr>";
                if ($alternate_rowcol==''){$alternate_rowcol=' class="altrowcol"';}else{$alternate_rowcol='';}
            }

            if (isset($_SESSION['cat']) && $_SESSION['cat']>0){
                $page=1;
                if (isset($_SESSION['page'])){$page=$_SESSION['page'];}
                $continue_shopping_url=category_url($_SESSION['cat'],$page);
            }
            else {$continue_shopping_url=cms_url;}

            if (display_type=='mobile'){$colspan=2;}else{$colspan=3;}
            if (isset($_SESSION['checkout']['discount']) && $_SESSION['checkout']['discount']>0){
                $cart_page_content.="<tr><td colspan=\"".$colspan."\" align=\"right\"style=\"padding: 8px 5px 8px 0\">Discounts:</td><td align=\"right\">- ".currency_symbol.number_format($_SESSION['checkout']['discount'],2)."</td></tr>
                <tr><td colspan=\"".$colspan."\" align=\"right\" style=\"padding: 8px 5px 8px 0\"><b>Sub-Total (".display_cart_item_count()."):</b></td><td align=\"right\"><b>".currency_symbol.number_format($subtotal-$_SESSION['checkout']['discount'],2)."</b></td></tr>";
            }else{
                $cart_page_content.="<tr><td colspan=\"".$colspan."\" align=\"right\" style=\"padding: 8px 5px 8px 0\"><b>Sub-Total (".display_cart_item_count()."):</b></td><td align=\"right\"><b>".currency_symbol.number_format($subtotal,2)."</b></td></tr>";
            }

            if (display_type=='mobile'){$colspan=3;}else{$colspan=4;}

            //$cart_page_content.="<tr><td colspan=\"".$colspan."\" align=\"right\" style=\"padding: 10px\"><a href=\"".$continue_shopping_url."\"><img src=\"".display_theme_file_loc('images/shop/continue_shopping.png',1)."\" style=\"margin: 6px\"></a><input type=\"image\" src=\"".display_theme_file_loc('images/shop/update_cart.png',1)."\" alt=\"Update Cart\" style=\"margin: 6px\"><a href=\"".cms_url."?order_stage=checkout\"><img src=\"".display_theme_file_loc('images/shop/checkout.png',1)."\" alt=\"Checkout\" style=\"margin: 6px\" /></a></td></tr>";
            $cart_page_content.="<tr><td colspan=\"".$colspan."\" align=\"right\" style=\"padding: 10px\"><button type=\"submit\" formaction=\"".$continue_shopping_url."\" class=\"btn btn_continue_shopping\">".$txt['btn_continue_shopping']."</button><button type=\"submit\" class=\"btn btn_continue_shopping\">".$txt['btn_update_cart']."</button><button type=\"submit\" formaction=\"".cms_url."?order_stage=checkout\" class=\"btn btn_checkout\">".$txt['btn_checkout']."</button></td></tr>";




            $cart_page_content.="</tbody></table></form>";
		}
		
		$page_content['main'].='<h1>'.$txt['cart_name'].'</h1>';
		if (isset($_SESSION['cart']['products']) && count($_SESSION['cart']['products'])>0){$page_content['main'].=$cart_page_content;}
		else{$page_content['main'].='<p>'.$txt['cart_empty'].'</p>';}

		// display cart category product list
		$category_details=get_category_details(1);
		$page_output=display_category($category_details,1);
		$page_content['main'].=$page_output['content']['main'];

        // if (admin_level()>9 && isset($_SESSION['checkout']['coupons'])){ echo "<pre>"; print_r($_SESSION['checkout']['coupons']); echo "</pre>"; exit;}


?>
