<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}

    require(cms_root_dir.'language/'.$cms_settings['config']['language'].'/shop_confirm_order.php');

/*
    $tax_amount=0;
    foreach($_SESSION['cart']['products'] as $product_option_id => $product){

        $tax_group[$product['tax_rate']]=$product_option_id;

    }
*/

	// set page title
	$page_title=$txt['shop_confirm_order_page_title'];

	// go to cart if no items ordered
	if (!isset($_SESSION['cart']['products']) || count($_SESSION['cart']['products'])<1){
        // redirect to cart
        header('HTTP/1.1 303 See Other');
        header("Location: ".cms_url."?cart");
        exit();
    }


    if (!isset($_SESSION['checkout']['customer_id']) && email_registered($_SESSION['checkout']['email'])){
		// go to checkout if email is registered but customer is not logged in
		$_SESSION['order_stage']="checkout";
		// redirect after form submit so browser back and refresh work without browser resend form data warning
        header('HTTP/1.1 303 See Other');
        header("Location: ".cms_url."?order_stage=checkout");
        exit();
	}

    // order total including shipping - this not used anymore?
    //$order_total=$_SESSION['checkout']['shipping_total']+$_SESSION['cart']['subtotal'];

    $current_time=time();

    // apply a coupon to order
    if (isset($rvi_apply_coupon)){
        if ($coupons=get_items('coupons',null,1,null,null,null,null,null,array('type','code'))){
            $coupon_count=count($coupons);
            $rvi_coupon_code=strtolower(trim($rvi_coupon_code));
            for ($item_num=0; $item_num<$coupon_count; $item_num++){
               if (strtolower($coupons[$item_num]['code'])==$rvi_coupon_code){
                    //$coupon_details=get_item_details('coupon',$coupons[$item_num]['id']);

                    // clear session coupons if this coupon is a solo coupon or solo coupon already in session
                    $clear_session_coupons=0;
                    if ($coupons[$item_num]['type']==1){$clear_session_coupons=1;}
                    elseif(isset($_SESSION['applied_coupons'])){
                        foreach ($_SESSION['applied_coupons'] as $coupon_id => $value){
                            if ($coupon_details=get_item_details('coupon',$coupon_id)){
                                if ($coupon_details['type']==1){$clear_session_coupons=1;break;}
                            }

                        }
                    }
                    // clear session coupons if there is already a solo coupon
                    if ($clear_session_coupons>0){unset($_SESSION['applied_coupons']);}

                    $_SESSION['applied_coupons'][$coupons[$item_num]['id']]=1;
                    break;
               }
            }
        }
        // redirect after form submit so browser back and refresh work without browser resend form data warning
        header('HTTP/1.1 303 See Other');
        header("Location: ".cms_url."?order_stage=confirm_order");
        exit();
    }

    // auto-apply coupons
    include_once(cms_root_dir.'includes/shop/coupon_auto_apply.php');

    // display order details
    $_SESSION['checkout']['products']=$_SESSION['cart']['products'];
    $_SESSION['checkout']['order_subtotal']=$_SESSION['cart']['subtotal'];
    $_SESSION['checkout']['total']=$_SESSION['cart']['subtotal']+$_SESSION['checkout']['shipping_total']-$_SESSION['checkout']['discount'];
    $order_details=$_SESSION['checkout'];
    //$edit_cart_link="- <a href=\"".cms_url."?cart\">Edit</a>";
    include(cms_root_dir.'includes/shop/order_details_table.php');

    if (isset($rvi_confirm)){

    	// save unverified customer details if not logged in
    	if (!isset($_SESSION['checkout']['customer_id'])){

    		// create customer id and check it does not already exist
    		$check_customer=TRUE;
    		while($check_customer==TRUE){
    			$customer_id=$current_time.rand(100,999);
    			if (get_item_details('customer',$customer_id)==FALSE){$check_customer=FALSE;}
    		}

            $_SESSION['checkout']['customer_id']=$customer_id;

            // save customer details
            $customer_details['item_type']='customer';
            $customer_details['id']=$customer_id;
            $customer_details['verified']='0';

            // generate a random password
            $password=generate_password();
            $customer_details['password']=encrypt_password($password,$customer_details['id']);

            $customer_details['status']='1';
            $customer_details['registered_timestamp']=$current_time;
            if (isset($_SESSION['referrer'])){$customer_details['referrer']=$_SESSION['referrer'];}
            $customer_details['name']=$_SESSION['checkout']['name'];
            $customer_details['email']=$_SESSION['checkout']['email'];
            $customer_details['phone']=$_SESSION['checkout']['phone'];

            $customer_details['address']=$_SESSION['checkout']['address'];
            $customer_details['address_2']=$_SESSION['checkout']['address_2'];
            $customer_details['city']=$_SESSION['checkout']['city'];
            $customer_details['postcode']=$_SESSION['checkout']['postcode'];
            $customer_details['county']=$_SESSION['checkout']['county'];
            $customer_details['country']=$_SESSION['checkout']['country'];

            $customer_details['dob_day']='---';
            $customer_details['dob_month']='---';
            $customer_details['dob_year']='---';

            $customer_details['newsletter_subscription']="yes";

            save_item_details($customer_details);
            update_item_list_file('customers',array($customer_details['id']),'add');

            // log new user in (still unvereified until user logs in with emailed password) - pehaps use the login feature
            unset($customer_details['password']);
            $_SESSION['reg_user']=$customer_details;

            update_item_log('user',$_SESSION['reg_user']['id'],"New user account registered via order - ".$customer_details['name']." ".$customer_details['id']);

            $send_new_user_email=1;

    	}

    	// save order in orders folder
        $_SESSION['checkout']['item_type']='order';
    	$order_id=$current_time.rand(100,999);
    	$_SESSION['checkout']['id']=$order_id;
        $_SESSION['checkout']['order_timestamp']=$current_time;
        // order status 0=unpaid, 1=paid, 2=paid and processed, 3=cancelled, 4=pending
    	$_SESSION['checkout']['status']=0;
    	if (isset($_SESSION['referrer'])){
    		$_SESSION['checkout']['referrer']=$_SESSION['referrer'];
    		$referrer_details=get_item_details('customer',$_SESSION['referrer']);
    		if (is_array($referrer_details)){
    			// write order number to referrers referred orders file
    			$fn=sys_data_dir.'/customers/'.$referrer_details['id'].'/referrals.php';
    			$fo=fopen($fn,"a");
    			fwrite($fo,"order|".$order_id."||\n");
    			fclose($fo);
    		}
    	}

        $_SESSION['checkout']['ip_address']=$_SERVER['REMOTE_ADDR'];

        // check for subscriptions and add to customers subscriptions file
        foreach($_SESSION['cart']['products'] as $product_option_id => $product){
            if (isset($_SESSION['cart']['products'][$product_option_id]['subscription']) && $_SESSION['cart']['products'][$product_option_id]['subscription']>0){$subscription_products[]=$product_option_id;}
        }
        
        // save new subscriptions
        if (isset($subscription_products)){
            $num=0;
            foreach ($subscription_products as $product_option_id){
                $subscription_details['item_type']='subscription';
                $subscription_details['id']=($current_time+$num).rand(100,999);

                $_SESSION['cart']['products'][$product_option_id]['subscription_id']=$subscription_details['id'];

                $subscription_details['product']=$_SESSION['cart']['products'][$product_option_id];
                $subscription_details['customer_id']=$_SESSION['checkout']['customer_id'];
                $subscription_details['order_id']=$order_id;

                // make subscription name using selected product options if any
                $subscription_details['name']=$_SESSION['cart']['products'][$product_option_id]['name'];
                if (isset($_SESSION['cart']['products'][$product_option_id]['option'])){
                    $subscription_name_text="";
                    foreach ($_SESSION['cart']['products'][$product_option_id]['option'] as $option => $value){
                        if ($subscription_name_text!=''){$subscription_name_text.=", ";}
                        $subscription_name_text.=$option.': '.$value;
                    }
                    $subscription_details['name']=$_SESSION['cart']['products'][$product_option_id]['name']." (".$subscription_name_text.")";
                }

                $subscription_details['days']=$_SESSION['cart']['products'][$product_option_id]['subscription'];
                $subscription_details['start_time']=0;
                $subscription_details['status']=0;
                save_item_details($subscription_details);
                $num++;
                $update_subscription_ids[]=$subscription_details['id'];
            }
            update_item_list_file('subscriptions',$update_subscription_ids,'add');
        }

        // save order details
        save_item_details($_SESSION['checkout']);
        update_item_list_file('orders',array($_SESSION['checkout']['id']),'add');

        update_item_log('user',$_SESSION['reg_user']['id'],"New order via cart - ".$_SESSION['checkout']['id']." by ".short_name($_SESSION['reg_user']['name'],2)." ".$_SESSION['reg_user']['id']);

        // write coupon codes to customers coupon file and check for use once only coupons and set to inactive
        if (isset($_SESSION['checkout']['coupons'])){
            // write coupon number to customers coupon file
			$fn=sys_data_dir.'/customers/'.$_SESSION['checkout']['customer_id'].'/coupons.php';
			$fo=fopen($fn,"a");
            foreach ($_SESSION['checkout']['coupons'] as $coupon_id => $coupon_details){
                fwrite($fo,$order_id."|".$coupon_id."|\n");
                // check for use once only coupons and set status to inactive
                if ($coupon_details['uses']==1){
                    $coupon_details['status']=0;
                    save_item_details($coupon_details);
                    update_item_list_file('coupons',array($coupon_details['id']));
                }
            }
            fclose($fo);
        }

    	// email customer order confirmation with payment link
    	require_once(cms_root_dir.'plugins/PHPMailer/class.phpmailer.php');

    	$mail = new PHPMailer();

        // send mail via smtp if set in config file
        if (defined('smtp_host')){
            $mail->IsSMTP(); // send via SMTP
            $mail->SMTPAuth = true; // turn on SMTP authentication
            $mail->SMTPSecure = 'ssl';
            $mail->Username = smtp_username; // SMTP username
            $mail->Password = smtp_password; // SMTP password
            $mail->Host       = smtp_host; // SMTP server
            $mail->Port       = smtp_port; // SMTP server
        }

    	// send customer order confirmation email
    	$mail->ClearAddresses();
    	$mail->From = $cms_settings['config']['site_email'];
    	$mail->FromName = cms_site_name;
    	$mail->AddAddress($_SESSION['checkout']['email']);

    	$mail->Subject = cms_site_name." - Order # ".$order_id;


    	$body_content="<p><b>Order # ".$order_id."</b></p>
    	<p><b>Customer Details</b><br>Name: ".$_SESSION['checkout']['name']."<br>Email: ".$_SESSION['checkout']['email']."<br>Phone: ".$_SESSION['checkout']['phone']."</p>
    	<p><b>Billing Address</b>";
    	$body_content.="<br>".$_SESSION['checkout']['address'].",";
    	if (strlen($_SESSION['checkout']['address_2'])>0){$body_content.="<br>".$_SESSION['checkout']['address_2'].",";}
    	$body_content.="<br>".$_SESSION['checkout']['city'].",<br>".$_SESSION['checkout']['county'].",";
    	if (strlen($_SESSION['checkout']['postcode'])>0){$body_content.="<br>".$_SESSION['checkout']['postcode'].",";}
    	$body_content.="<br>".$_SESSION['checkout']['country']."</p>";

        if ($_SESSION['checkout']['delivery_seperate_details']<1){$body_content.="<p><b>Delivery Address</b><br>Same as billing address</p>";}
    	else{$body_content.="<p><b>Delivery Address</b><br>".stripslashes($_SESSION['checkout']['delivery_name'])."<br>".$_SESSION['checkout']['delivery_address'].",";
    	if (strlen($_SESSION['checkout']['delivery_address_2'])>0){$body_content.="<br>".$_SESSION['checkout']['delivery_address_2'].",";}
    	$body_content.="<br>".$_SESSION['checkout']['delivery_city'].",<br>".$_SESSION['checkout']['delivery_county'].",";
    	if (strlen($_SESSION['checkout']['delivery_postcode'])>0){$body_content.="<br>".$_SESSION['checkout']['delivery_postcode'].",";}
    	$body_content.="<br>".$_SESSION['checkout']['delivery_country']."</p>";}

    	if (strlen($_SESSION['checkout']['delivery_phone'])>0){$body_content.="<p><b>Delivery Tel:</b> ".$_SESSION['checkout']['delivery_phone']."</p>";}
    	if ($_SESSION['checkout']['delivery_date_month']>0){$body_content.="<p><b>Delivery Date:</b> ".$_SESSION['checkout']['delivery_date_day']."/".$_SESSION['checkout']['delivery_date_month']."/".$_SESSION['checkout']['delivery_date_year']."</p>";}
    	if (strlen($_SESSION['checkout']['delivery_message'])>0){$body_content.="<div style=\"width: 200px;\"><b>Greeting Card:</b> ".$_SESSION['checkout']['delivery_message']."</div>";}

        $body_content.=$order_details_table;

    	$mail->Body    = str_replace('{order_id}',$order_id,$txt['shop_confirm_order_email'])."<hr>".$body_content;
    	$mail->IsHTML(TRUE);

    	if($mail->Send()){update_item_log('user',$_SESSION['reg_user']['id'],"Order ".$order_id." notification email sent to ".short_name($_SESSION['checkout']['name'],2));}
        else{update_item_log('user',$_SESSION['reg_user']['id'],"Warning: order ".$order_id." notification email to ".short_name($_SESSION['checkout']['name'],2)." could not be sent");}

    	// email order notification to shop owner
    	$mail->ClearAddresses();
    	$mail->From = $cms_settings['config']['site_email'];
    	$mail->FromName = cms_site_name;
    	$mail->AddAddress($cms_settings['config']['site_email']);
    	$mail->AddReplyTo($_SESSION['checkout']['email'], $_SESSION['checkout']['name']);

    	$mail->Subject = cms_site_name." - Order # ".$order_id;
    	$mail->Body="<p>An order has been placed on your website and it's details can be viewed below..</p><p>** Please note this email is not confirmation of payment. **</p><p><a href=\"".cms_root_url."admin/?modify_order=".$order_id."\">Login to the website</a> to modify this order or update it's status.</p> Customer IP Address: ".$_SERVER['REMOTE_ADDR'].$body_content;
    	$mail->IsHTML(TRUE);

    	if(!$mail->Send()){update_log("Warning: order ".$order_id."  notification email to admin could not be sent");}

    	// send customer registration email if they're not already registered
    	if (isset($send_new_user_email)){

    		// send confirmation email to user
    		$mail->ClearAddresses();
    		$mail->From = $cms_settings['config']['site_email'];
    		$mail->FromName = cms_site_name;
    		$mail->AddAddress($_SESSION['checkout']['email']);

    		$mail->Subject = cms_site_name." - New Account Registration";
    		$mail->Body    = "Hi ".short_name($customer_details['name']).",\n\nThank you for registering with ".cms_site_name." - Your new login password is ".$password."\n\nClick on the link below to login.\n\n".user_login_link($customer_details)."\n\nThis is an automated email; if you received it in error, no action is required.\n\n".cms_site_name."\n".cms_site_url;
    		$mail->IsHTML(FALSE);

    		if(!$mail->Send()){update_item_log('user',$_SESSION['reg_user']['id'],"Warning: user registration email could not be sent");}

    	}

    	// clear checkout variables
        unset($_SESSION['checkout']['id']);
    	unset($_SESSION['checkout']['customer_id']);
    	unset($_SESSION['cart']);
        if (isset($_SESSION['checkout']['shipping_option'])){unset($_SESSION['checkout']['shipping_option']);}
        if (isset($_SESSION['applied_coupons'])){unset($_SESSION['applied_coupons']);}

    	$_SESSION['order_stage']='checkout';
    	// redirect after form submit so browser back and refresh work without browser resend form data warning
        header('HTTP/1.1 303 See Other');
        header("Location: ".cms_url."?paynow=".$order_id);
        exit();

    }
    else{

        $include_font_icons=1;

    	$page_content['main'].="<a name=\"order_details\"></a><h1>Confirm Order</h1>";

    	$page_content['main'].="<div class=\"confirm_order\"><div class=\"confirm_order_address\">
        <div>
        <p><a href=\"".cms_url."?order_stage=checkout&amp;edit\" class=\"edit_link\">Your Details <i class=\"far fa-edit\"></i></a><br />Name: ".$_SESSION['checkout']['name']."<br />Email: ".$_SESSION['checkout']['email']."<br />Phone: ".$_SESSION['checkout']['phone']."</p>
        </div><div>
        <p><a href=\"".cms_url."?order_stage=checkout&amp;edit\" class=\"edit_link\">Billing Address <i class=\"far fa-edit\"></i></a>";
    	if (strlen($_SESSION['checkout']['address'])>0){$page_content['main'].="<br />".$_SESSION['checkout']['address'].",";}
    	if (strlen($_SESSION['checkout']['address_2'])>0){$page_content['main'].="<br />".$_SESSION['checkout']['address_2'].",";}
    	if (strlen($_SESSION['checkout']['city'])>0){$page_content['main'].="<br />".$_SESSION['checkout']['city'].",";}
        if (strlen($_SESSION['checkout']['county'])>0){$page_content['main'].="<br />".$_SESSION['checkout']['county'].",";}
    	if (strlen($_SESSION['checkout']['postcode'])>0){$page_content['main'].="<br />".$_SESSION['checkout']['postcode'].",";}
    	if ($_SESSION['checkout']['country']!='---'){$page_content['main'].="<br />".$_SESSION['checkout']['country']."</p>";}

        $page_content['main'].="</div><div>";

    	if ($_SESSION['checkout']['delivery_seperate_details']<1){$page_content['main'].="<p><a href=\"".cms_url."?order_stage=checkout&amp;edit\" class=\"edit_link\">Delivery Address <i class=\"far fa-edit\"></i></a><br />Same as billing address</p>";}
    	else {$page_content['main'].="<p><b>Delivery Address</b> - <a href=\"".cms_url."?order_stage=checkout&amp;edit\"><i class=\"far fa-edit\"></i></a>";
        $page_content['main'].="<br />".$_SESSION['checkout']['delivery_name'];
        if (strlen($_SESSION['checkout']['delivery_address'])>0){$page_content['main'].="<br />".$_SESSION['checkout']['delivery_address'].",";}
        if (strlen($_SESSION['checkout']['delivery_city'])>0){$page_content['main'].="<br />".$_SESSION['checkout']['delivery_city'].",";}
        if (strlen($_SESSION['checkout']['delivery_county'])>0){$page_content['main'].="<br />".$_SESSION['checkout']['delivery_county'].",";}
        if (strlen($_SESSION['checkout']['delivery_postcode'])>0){$page_content['main'].="<br />".$_SESSION['checkout']['delivery_postcode'].",";}
        if ($_SESSION['checkout']['delivery_country']!='---'){$page_content['main'].="<br />".$_SESSION['checkout']['delivery_country'];}
        $page_content['main'].="</p>";}

        if (strlen($_SESSION['checkout']['delivery_phone'])>0){$page_content['main'].="<p>Delivery Tel: ".$_SESSION['checkout']['delivery_phone']."</p>";}
    	if ($_SESSION['checkout']['delivery_date_month']>0){$page_content['main'].="<p>Requested Delivery Date: ".$_SESSION['checkout']['delivery_date_day']."/".$_SESSION['checkout']['delivery_date_month']."/".$_SESSION['checkout']['delivery_date_year']."</p>";}
    	if (strlen($_SESSION['checkout']['delivery_message'])>0){$page_content['main'].="<div style=\"width: 200px;\">Greeting Card: ".$_SESSION['checkout']['delivery_message']."</div>";}

    	$page_content['main'].="</div></div>";

        // display order details
        $page_content['main'].="<div class=\"confirm_order_items\">";
        $order_details_table=str_replace($cart_items_heading,"<a href=\"".cms_url."?cart\">".$txt['invoice_items_heading']." <i class=\"fas fa-shopping-cart\"></i></a>",$order_details_table);
        $page_content['main'].=$order_details_table."</div>";

    	//$page_content['main'].="<tr><td align=\"right\" ".(display_type=='mobile' ? "" : "colspan=\"2\" ")."style=\"padding: 2px\"><form action=\"".cms_url."?order_stage=confirm_order#order_details\" method=\"post\"><input type=\"text\" name=\"coupon_code\" /> <input type=\"image\" name=\"apply_coupon[]\" src=\"".display_theme_file_loc('images/shop/apply_coupon.png',1)."\" style=\"vertical-align:middle;\" /> <input type=\"image\" name=\"confirm[]\" src=\"".display_theme_file_loc('images/shop/confirm_order.png',1)."\" style=\"vertical-align:middle;\" /></form></td></tr></table>";
        $page_content['main'].="<div style=\"flex: 0 0 100%\"><form action=\"".cms_url."?order_stage=confirm_order#order_details\" class=\"cms_form\" method=\"post\"><div class=\"form_row_footer form_row_small\"><input type=\"text\" name=\"coupon_code\" placeholder=\"Coupon code\" style=\"display: inline-block; margin-right: 10px\"  /><button type=\"submit\" name=\"apply_coupon\" class=\"btn btn_continue_shopping\">".$txt['btn_apply_coupon']."</button> <button type=\"submit\" name=\"confirm\" class=\"btn btn_checkout\">".$txt['btn_confirm_order']."</button></div></form></div>
        </div>";
    }

?>
