<?php
// exit if php file is loaded directly and not included
if (!defined("cms_version_number")){exit();}


    if (isset($order_details['currency_code'])){
        $currency_code=$order_details['currency_code'];
        $currency_symbol=get_currency_symbol($order_details['currency_code']);
    }
    else{
        $currency_code=currency_code;
        $currency_symbol=currency_symbol;
    }



    if (isset($order_details['products']) && !empty($order_details['products'])){
        $tax_heading="Tax";
    }else{$tax_heading="";}

    // cart_items_heading as variable so it can be replaced with an edit cart link on confirm order page
    $cart_items_heading="<span class=\"cart_items_heading\" style=\"font-weight: bold\">".$txt['invoice_items_heading']."</span>";

    $order_details_table="<table width=\"100%\" cellpadding=\"2\" class=\"table_no_border\" style=\"margin-bottom: 10px\">\n
    <tr><td colspan=\"2\" >".$cart_items_heading."</td><td width=\"50\" align=\"center\" style=\"padding: 6px 10px 6px 10px\"><b>".$tax_heading."</b></td><td width=\"80\" align=\"right\" style=\"padding-left:10px\"><b>Total</b></td></tr>\n";
    //$tax_amount=0;
    $subtotal=0;
    if (isset($order_details['products']) && !empty($order_details['products'])){
    	foreach($order_details['products'] as $product_option_id => $product){

    		if (isset($product['code']) && strlen($product['code'])>0){$product_code="(".$product['code'].") ";}else{$product_code="";}

            if (isset($product['cancelled'])){$style_cancelled=" text-decoration: line-through";}else{$style_cancelled="";}

    		$order_details_table.="<tr><td valign=\"top\" width=\"30\" nowrap><span style=\"".$style_cancelled."\">".$product['order_qty']." x</span></td><td><span style=\"font-weight: bold;".$style_cancelled."\">".$product_code.htmlentities($product['name'])."</span>";

            if (isset($rvi_modify_order) && admin_level('orders')>1){
                $order_details_table.=" <a href=\"".cms_root_url."admin/?modify_order=".$order_details['id']."&amp;eproduct=".$product_option_id."\" title=\"Edit item\"><i class=\"fas fa-edit\"></i></a>";
                if (!isset($product['cancelled'])){$order_details_table.=" <a href=\"".cms_root_url."admin/?modify_order=".$order_details['id']."&amp;cproduct=".$product_option_id."\" title=\"Cancel item\"><i class=\"fas fa-toggle-on\"></i></a>";}
                else{$order_details_table.=" <a href=\"".cms_root_url."admin/?modify_order=".$order_details['id']."&amp;restoreproduct=".$product_option_id."\" title=\"Restore item\"><i class=\"fas fa-toggle-off\"></i></a>";}
                if (isset($product['item_type']) && $product['item_type']=='order_amendment'){
                    $order_details_table.=" <a href=\"".cms_root_url."admin/?modify_order=".$order_details['id']."&amp;rproduct=".$product_option_id."\" title=\"Remove item\" onclick=\"return confirm('Are you sure you want to remove this item from the order?')\"><i class=\"fas fa-trash\"></i></a>";
                }
            }

            if (isset($product['option'])){
                $order_details_table.="<div style=\"font-size: 12px;\">";
                foreach ($product['option'] as $option => $value){
                    $order_details_table.=$option.': '.$value.'<br />';
                }
                $order_details_table.="</div>";
            }

    		if (isset($product['customer_note']) && strlen($product['customer_note'])>0){$order_details_table.="<div style=\"font-size: 12px;\"><span style=\"".$style_cancelled."\">Instructions/Notes: ".$product['customer_note']."</span></div>";}
    		if (isset($product['uploaded_file'])){$order_details_table.="<div style=\"font-size: 12px;\"><span style=\"".$style_cancelled."\">File: ".$product['uploaded_file']."</span></div>";}

            if (isset($product['admin_note']) && strlen($product['admin_note'])>0){$order_details_table.="<div style=\"font-size: 11px; color: #333\"><span style=\"".$style_cancelled."\">".nl2br($product['admin_note'])."</span></div>";}

            if (admin_level()>0 && !isset($rvi_print_invoice)){
                if (isset($product['listing_id'])){$order_details_table.='<div>'.$txt['Listing'].' Ref: <a href="'.item_url('listing',$product['listing_id']).'" target="_blank">'.$product['listing_id'].'</a> - <a href="'.cms_root_url.'admin/?modify_listing='.$product['listing_id'].'">Modify</a></div>';}
                if (isset($product['subscription_id'])){$order_details_table.='<div>'.$txt['Subscription'].' Ref: <a href="'.cms_root_url.'admin/?modify_subscription='.$product['subscription_id'].'">'.$product['subscription_id'].'</a></div>';}
            }
            else{
                if (isset($product['listing_id'])){$order_details_table.='<div>'.$txt['Listing'].' Ref: '.$product['listing_id'].'</div>';}
                if (isset($product['subscription_id'])){$order_details_table.='<div>'.$txt['Subscription'].' Ref: '.$product['subscription_id'].'</div>';}
            }

            $total_product_order_price=$product['order_price']*$product['order_qty'];
            // calculate tax amount
    		if ($product['tax_rate']>0 && !isset($product['cancelled'])){
      			$tax_value=($product['tax_rate']/100)+1;
      			$price_excl_tax=$total_product_order_price-($total_product_order_price/$tax_value);
                if (isset($tax_amount[$product['tax_rate']])){$tax_amount[$product['tax_rate']]=$tax_amount[$product['tax_rate']]+$price_excl_tax;}
                else{$tax_amount[$product['tax_rate']]=$price_excl_tax;}
    		}
            if ($cms_settings['b2b']>0){$total_product_order_price=$total_product_order_price/(($product['tax_rate']/100)+1);}
            if (!isset($product['cancelled'])){$subtotal=$subtotal+$total_product_order_price;}

    		$order_details_table.="</td><td align=\"center\" valign=\"top\" style=\"padding: 2px 10px 2px 10px\"><span style=\"".$style_cancelled."\">".floatval($product['tax_rate'])."%</span></td><td align=\"right\" valign=\"top\" style=\"padding-left:10px\"><span style=\"".$style_cancelled."\">".$currency_symbol.number_format($total_product_order_price,2)."</span></td></tr>\n";

    	}
    }
    elseif(isset($rvi_invoice) || isset($rvi_print_invoice)){$order_details_table.="<tr><td colspan=\"4\" style=\"line-height: 22px\"><hr style=\"color: #cccccc\"><br><hr style=\"color: #cccccc;\"><br><hr style=\"color: #cccccc\"><br><hr style=\"color: #cccccc\"><br><hr style=\"color: #cccccc\"><br><hr style=\"color: #cccccc\"><br><hr style=\"color: #cccccc\"><br><hr style=\"color: #cccccc\"><br></td></tr>\n";}

    $order_details_table.="<tr><td colspan=\"4\"><hr></td></tr>\n";

    if ((isset($rvi_invoice) || isset($rvi_print_invoice)) && (!isset($order_details['products']) || empty($order_details['products']))){
        $order_details_table.="<tr><td colspan=\"3\" align=\"right\"><b>Sub-Total</b>:</td><td align=\"right\"><span style=\"color: #cccccc;line-height:24px\">___________________</span></td></tr>\n";
    }
    else{
        $order_details_table.="<tr><td colspan=\"3\" align=\"right\">Sub-Total:</td><td align=\"right\">".$currency_symbol.number_format($subtotal,2)."</td></tr>\n";
    }

    if (isset($tax_amount)){
        foreach ($tax_amount as $tax_rate => $value){
            $order_details_table.="<tr><td colspan=\"3\" align=\"right\">Tax @ ".floatval($tax_rate)."%:</td><td align=\"right\">".$currency_symbol.number_format($value,2)."</td></tr>\n";
        }
    }

    if (isset($order_details['shipping_option'])){
        $order_details_table.="<tr><td colspan=\"4\"><b>Shipping</b></td></tr>\n";

        $user_shipping_info="";
        if (isset($order_details['shipping_option']['user_shipping_info'])){
            foreach ($order_details['shipping_option']['user_shipping_info'] as $name => $value){
                if ($value!=""){
                    $user_shipping_info="<br>".$name.": ".$value;
                }
            }
        }

        $order_details_table.="<tr><td colspan=\"3\">".$order_details['shipping_option']['name'].$user_shipping_info."</td><td align=\"right\" valign=\"top\" style=\"padding-left:10px\">".$currency_symbol.number_format($order_details['shipping_total'],2)."</td></tr>\n";
        $order_details_table.="<tr><td colspan=\"4\"><hr /></td></tr>\n";
    }
    else{
        if ((isset($rvi_invoice) || isset($rvi_print_invoice)) && (!isset($order_details['products']) || empty($order_details['products']))){
           $order_details_table.="<tr><td colspan=\"3\" align=\"right\"><b>Shipping</b>:</td><td align=\"right\"><span style=\"color: #cccccc;line-height:24px\">___________________</span></td></tr>\n";
        }
        else{
            $order_details_table.="<tr><td colspan=\"3\" align=\"right\">Shipping:</td><td align=\"right\">".$currency_symbol.number_format($order_details['shipping_total'],2)."</td></tr>\n";
        }
    }

    //if (isset($order_details['coupons']) && $order_details['discount']>0){
    if (isset($order_details['coupons'])){
        $order_details_table.="<tr><td colspan=\"3\" align=\"right\">Total:</td><td align=\"right\">".$currency_symbol.number_format($order_details['order_subtotal']+$order_details['shipping_total'],2)."</td></tr>\n";
        $order_details_table.="<tr><td colspan=\"4\"><b>Discounts</b></td></tr>\n";
        foreach ($order_details['coupons'] as $coupon_id => $value){
            if ($value['discount']>0){

                if (isset($value['cancelled'])){$style_cancelled=" text-decoration: line-through";}else{$style_cancelled="";}

                $order_details_table.="<tr><td colspan=\"3\"><span style=\"".$style_cancelled."\">".($value['description']!="" ? $value['description'] : $value['code'])."</span>";
                if (isset($rvi_modify_order) && admin_level('orders')>1){
                    if (isset($value['cancelled'])){$order_details_table.=" <a href=\"".cms_root_url."admin/?modify_order=".$order_details['id']."&amp;restorediscount=".$coupon_id."\" title=\"Restore coupon\"><i class=\"fas fa-toggle-off\"></i></a>";}
                    else{$order_details_table.=" <a href=\"".cms_root_url."admin/?modify_order=".$order_details['id']."&amp;cdiscount=".$coupon_id."\" title=\"Cancel coupon\"><i class=\"fas fa-toggle-on\"></i></a>";}
                }
                $order_details_table.="</td><td align=\"right\" valign=\"top\" style=\"padding-left:10px\"><span style=\"".$style_cancelled."\">- ".$currency_symbol.number_format($value['discount'],2)."</span></td></tr>\n";
            }
        }
        $order_details_table.="<tr><td colspan=\"4\"><hr /></td></tr>";
        // $order_details_table.="<tr><td colspan=\"3\" align=\"right\">Total Discount:</td><td align=\"right\">- ".$currency_symbol.number_format($order_details['discount'],2)."</td></tr>";

        $order_total=$order_details['order_subtotal']+$order_details['shipping_total']-$order_details['discount'];
        if ($order_total<0){$order_total=0;}
        $order_details_table.="<tr><td colspan=\"3\" align=\"right\" style=\"font-size: 14px\"><b>Total:</b></td><td align=\"right\" style=\"font-size: 14px\"><b>".$currency_symbol.number_format($order_total,2)."</b></td></tr>\n";
    }
    else{

        $order_total=$order_details['order_subtotal']+$order_details['shipping_total'];
        if ($order_total<0){$order_total=0;}
        if ((isset($rvi_invoice) || isset($rvi_print_invoice)) && (!isset($order_details['products']) || empty($order_details['products']))){
           $order_details_table.="<tr><td colspan=\"3\" align=\"right\"><b>Total</b>:</td><td align=\"right\"><span style=\"color: #cccccc;line-height:24px\">___________________</span></td></tr>\n";
        }
        else{
            $order_details_table.="<tr><td colspan=\"3\" align=\"right\"><b>Total</b>:</td><td align=\"right\"><b>".$currency_symbol.number_format($order_total,2)."</b></td></tr>\n";
        }
    }

    $balance_due=$order_total;

    if (isset($order_details['payment'])){
         $payment_details_table="";
        foreach($order_details['payment'] as $payment_id => $payment){

            if (!is_array($payment)){continue;} // legacy

            if (isset($payment['cancelled'])){$style_cancelled=" text-decoration: line-through";}else{$style_cancelled="";}

    		$payment_details_table.="<tr><td valign=\"top\" colspan=\"3\"><span style=\"".$style_cancelled."\">".date("d/m/Y",$payment['date'])." ".$payment['description']."</span>";

            if (isset($rvi_modify_order) && admin_level('orders')>1){
                if (!isset($payment['cancelled'])){$payment_details_table.=" <a href=\"".cms_root_url."admin/?modify_order=".$order_details['id']."&amp;cpayment=".$payment_id."\" title=\"Cancel payment\"><i class=\"fas fa-toggle-on\"></i></a>";}
                else{$payment_details_table.=" <a href=\"".cms_root_url."admin/?modify_order=".$order_details['id']."&amp;restorepayment=".$payment_id."\" title=\"Restore payment\"><i class=\"fas fa-toggle-off\"></i></a>";}
                $payment_details_table.=" <a href=\"".cms_root_url."admin/?modify_order=".$order_details['id']."&amp;rpayment=".$payment_id."\" title=\"Remove payment\" onclick=\"return confirm('Are you sure you want to remove this payment from the order?')\"><i class=\"fas fa-trash\"></i></a>";
            }

            if (isset($payment['note']) && strlen($payment['note'])>0){$payment_details_table.="<div style=\"font-size: 12px;\"><span style=\"".$style_cancelled."\">".$payment['note']."</span></div>";}

            // calculate balance due after payments
            if (!isset($payment['cancelled'])){$balance_due=$balance_due-$payment['amount'];}

    		$payment_details_table.="</td><td align=\"right\" valign=\"top\" style=\"padding-left:10px\"><span style=\"".$style_cancelled."\">".$currency_symbol.number_format($payment['amount'],2)."</span></td></tr>\n";

    	}

        if ($payment_details_table!=""){
            $order_details_table.="<tr><td colspan=\"4\"><b>Payments</b></td></tr>\n".$payment_details_table;

            $order_details_table.="<tr><td colspan=\"3\" align=\"right\"><b>Balance Due</b>:</td><td align=\"right\"><b>".$currency_symbol.number_format($balance_due,2)."</b></td></tr>\n";
        }

    }


    $order_details_table.="</table>";


?>