<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}

	// set page title
	$page_title.="Order Payment";

	if (isset($rvi_paynow)){$order_details=get_item_details('order',$rvi_paynow);}


    if (!isset($order_details['id']) && !isset($rvi_amount)){
        $page_content['main'].="Error: Order details not found";
        return;
    }

    if (isset($order_details['currency_code'])){
        $currency_code=$order_details['currency_code'];
        $currency_symbol=get_currency_symbol($order_details['currency_code']);
    }
    else{
        $currency_code=currency_code;
        $currency_symbol=currency_symbol;
    }

/*
	$order_total=0;
    if ($cms_settings['b2b']>0){
        foreach($order_details['products'] as $product_option_id => $product){
            $order_total=$order_total+(($order_details['products'][$product_option_id]['price']+(($order_details['products'][$product_option_id]['price']/100)*$order_details['products'][$product_option_id]['tax_rate']))*$order_details['products'][$product_option_id]['qty']);
        }
        $order_total=$order_total+$order_details['shipping_total']-$order_details['discount'];
    }
    else{$order_total=$order_details['shipping_total']+$order_details['order_subtotal']-$order_details['discount'];}
    */
    if (isset($rvi_amount)){
        $order_total=$rvi_amount;
        $order_details['id']="a".time();
        $order_details['status']=0;
    }
    elseif(isset($rvi_deposit) && isset($order_details['deposit']) && $order_details['deposit']>0){
        $pay_deposit=1;
        $order_total=$order_details['deposit'];
        $order_total=round($order_total,2);
    }
    else{
        $order_total=$order_details['order_subtotal']+$order_details['shipping_total']-$order_details['discount'];

        // check for any payments made on the order
        if (isset($order_details['payment'])){
        	foreach($order_details['payment'] as $payment_id => $payment){
                if (isset($payment['amount'])){$order_total=$order_total-$payment['amount'];}
            }
        }

        $order_total=round($order_total,2);
    }

    // count how many standard/subscription products in order
    $standard_product_count=0;
    $sub_product_count=0;
    if (isset($order_details['products'])){
        foreach($order_details['products'] as $product_option_id => $product){
            if (isset($product['subscription_id'])){$sub_product_count++;}else{$standard_product_count++;}
        }
    }

    $payment_options="";

    // by default payment page is public but if any payment option requires customer to be logged in it will put the payment page behind login
    $paynow_login_required=0;

    // get payment options
    $dir=cms_root_dir.'includes/shop/payment_options';
    if ($handle=opendir($dir)){
      while (false!==($file=readdir($handle))){
          if ($file!='.' && $file!='..' && is_dir($dir.'/'.$file) && substr($file,0,1)!='_'){
                $paynow_fn=$dir.'/'.$file.'/paynow.php';
                if (file_exists($paynow_fn)){
                  if (isset($payment_option_details['status'])){unset($payment_option_details['status']);}
                  include($paynow_fn);
                  // don't show payment option if it's disabled
                  if (isset($payment_option_details['status']) && $payment_option_details['status']>0){
                    // only show payment option if it is enabled or in testmode and main admin user
                    if ($payment_option_details['status']==1 || admin_level()>9){
                		$payment_options.="<div class=\"payment_option\"><div class=\"payment_option_desc\"><h3>".$payment_option_details['name']."</h3><p style=\"font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 12px;\">".$payment_option_details['description']."</p></div><div class=\"payment_option_action\">".$payment_option_form."</div></div><hr />";
                    }
                  }
                }
          }
      }
    }

    // check permission to view the payment page
    if ($paynow_login_required>0 && admin_level()<1){
        if (!isset($_SESSION['reg_user']['id'])){
            $page_content['main'].="Please login below to view this page.";
            include(cms_root_dir."includes/users/login.php");
            $page_content['main'].=$login_form;
            return;
        }
        elseif($_SESSION['reg_user']['id']!=$order_details['customer_id']){
            $page_content['main'].="<h3>Access Restricted</h3><p>You do not have the required permissions to view this page. If you have more than one registered account please make sure you are logged into the correct one.</p>";
            return;
        }
    }


    // display warnings
    if (isset($_SESSION['form']['paynow']['warning_green'])){$page_content['main'].=display_warnings($_SESSION['form']['paynow']['warning_green'],'green');}


	if ($order_total>0){

		// show order sumary
		$page_content['main'].="<h1>Order Payment</h1><p>Order #: ".$order_details['id']."<br>".(isset($pay_deposit) ? "Deposit " : "")."Amount: <b>".$currency_symbol.number_format($order_total,2)."</b></p>";

        if (!isset($_SESSION['reg_user']) && $order_details['status']<3){
            $page_content['main'].="<p><a href=\"".cms_url."?login\">Login</a> to view your order.</p>";
        }

        // display payment options if unpaid
        if (trim($order_details['status'])==0 || trim($order_details['status'])>3){

			$page_content['main'].="<h2>Payment Options</h2><p>";

            // load payment_page_text
            $payment_page_text_fn=sys_data_dir.'/settings/payment_page_text.html';
            if (file_exists($payment_page_text_fn)){$page_content['main'].=   file_get_contents($payment_page_text_fn);}

            if ($payment_options!=""){$page_content['main'].="<div class=\"payment_options\">".$payment_options."</div>";}

		}
		elseif ($order_details['status']==1 || $order_details['status']==2){$page_content['main'].="This order has been paid.";}
        elseif ($order_details['status']==3){$page_content['main'].="This order has been cancelled.";}


	
	}
    else{$page_content['main'].="<h1>Order</h1><p>Order #: ".$order_details['id']."</p><p>Please allow 24hrs for order to be processed.</p>";}


?>
