<?php

    // ini_set("memory_limit","100M");
	// ini_set("max_execution_time","3600");

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}

    if (user_level('products')<1){
        $page_content['main'].="<h3>Access Restricted</h3><p>You do not have the required user permissions to view this page.</p>";
        return;
    }

	if ($product_details=get_item_details('product',$rvi_product)){

        if (isset($product_details['template'])){
            $page_template=$product_details['template'];
            // load config file from theme folder if it exists
            $template_config_fn=display_theme_dir.'config/'.$product_details['template'];
            if (file_exists($template_config_fn)){include($template_config_fn);}
        }

        if ($product_details['status']>1){include(cms_root_dir.'includes/page_not_found.php');return;}

		// check user access to product
		if (isset($product_details['user_group']) && admin_level('products')<1){
            $access_denied=1;
			foreach ($product_details['user_group'] as $user_group_id){
				if ($user_group_id==0){$access_denied=0;break;}
				if ($user_group_id==1 && isset($_SESSION['reg_user'])){$access_denied=0;break;}
                if ($user_group_id==2 && admin_level()>0){$access_denied=0;break;}
				if (isset($_SESSION['reg_user']['user_group'])){
					foreach($_SESSION['reg_user']['user_group'] as $customer_user_group){
						if ($customer_user_group==$user_group_id){$access_denied=0;break;}
					}
					if ($access_denied<1){break;}
				}
			}
            if ($access_denied>0){
    			$page_content['main'].="<h3>Access Restricted</h3><p>You do not have the required user permissions to view this page.</p>";
                return;
		    }
		}

        // ensure links in content are using the active cms_protocol http:// or https://
        // might want to put this into cache
        if (cms_protocol=='https://'){
            foreach ($product_details['content'] as $content_area_name => $value){
                $product_details['content'][$content_area_name]=str_replace('http://'.strip_url_protocol(cms_root_url),cms_root_url,$value);
                $product_details['content'][$content_area_name]=str_replace('http://'.strip_url_protocol(cms_url),cms_url,$value);
            }
        }
        else{
            foreach ($product_details['content'] as $content_area_name => $value){
                $product_details['content'][$content_area_name]=str_replace('https://'.strip_url_protocol(cms_root_url),cms_root_url,$value);
                $product_details['content'][$content_area_name]=str_replace('https://'.strip_url_protocol(cms_url),cms_url,$value);
            }
        }

        $page_content=$product_details['content'];
        $page_content['main']="";

		// output product detail
		$page_title.=htmlentities($product_details['name'],ENT_COMPAT,'UTF-8');

        // cached product page content
        // not worth caching product detail page unless there are alot of custom lookups  - is it worthwhile ?
        /*
        $no_cache=1;
        if (cache_enabled>0 && $no_cache<1 && admin_level()>9){
            if (strpos($product_details['content']['main'],'{contact_form}')!==false){$no_cache=1;}
            else{
            	// cache key
            	$cache_key=serialize($product_details).display_type;
            	$cache_key=$product_details['id'].'_'.md5($cache_key);
            	$cache_fn=sys_cache_dir.'/products/'.$cache_key.".cache";

            	// return cached content if it exists for faster page load
            	if (file_exists($cache_fn)){
                    $cached_content=explode('|cache|',file_get_contents($cache_fn));
            		$page_content['main'].=$cached_content[0];
                    $page_meta.=$cached_content[1];
                    $page_end.=$cached_content[2];
            		return;
            	}
            }
        }
        */

        // page meta tags
        $page_meta.="<link rel=\"canonical\" href=\"".item_url('product',$rvi_product,$product_details['slug'])."\" />";
		if (isset($product_details['short_description']) && strlen($product_details['short_description'])>0){$page_meta.="<meta name=\"description\" content=\"".htmlentities($product_details['short_description'],ENT_COMPAT,'UTF-8')."\" />";}
		if (isset($product_details['keywords']) && strlen($product_details['keywords'])>0){$page_meta.="<meta name=\"keywords\" content=\"".htmlentities($product_details['keywords'],ENT_COMPAT,'UTF-8')."\" />";}


		$page_content['main'].="<div class=\"product_detail\">";


           if ((isset($product_details['image']) && count($product_details['image'])>0) || (isset($product_details['youtube_video']) && strlen($product_details['youtube_video'])>0)){


                    // ovrerride main image size for mobile display
                    if (display_type=='mobile'){
            		    $main_image_size_x=264;
            		    $main_image_size_y=250;
                    }
                    else{
                        $main_image_size_x=$cms_settings['img']['width_main'];
            		    $main_image_size_y=$cms_settings['img']['height_main'];
                    }

            		// jquery galleria includes
                    $jquery_required=1;
                    $page_meta.="<style type=\"text/css\">.galleria{width: ".$main_image_size_x."px; height: ".$main_image_size_y."px;}</style>";
                    $page_end.="<script src=\"".cms_root_url."plugins/galleria_1_6_1/dist/galleria.min.js\"></script>
                    <script>
                    $(function() {
                        // Load the classic theme
                        Galleria.loadTheme('".cms_root_url."plugins/galleria_1_6_1/dist/themes/classic/galleria.classic.min.js');

                        // Initialize Galleria
                        Galleria.run('.galleria',{
                        debug: false,
                        showInfo: false,
                        lightbox: true,
                        wait: true"; // we need to set wait: true if gallery is hidden for example xara variants, needs to be visible to initialise properly without error

                        if (count($product_details['image'])<2){
                            $page_end.=",
                            showImagenav: false,
                            thumbnails: false";
                        }

                        $page_end.="});
                    });
                    </script>";


        			$product_path=sys_data_dir.'/products/'.$rvi_product.'/';

            		// set thumnail sizes for images
            		$tn_size_x=$cms_settings['img']['width_tn'];
            		$tn_size_y=$cms_settings['img']['height_tn'];

                    // $image_content='<div class=\"img_group\" style="width: '.$tn_size_x.'px">';
                    $image_content="<div class=\"galleria img_group\">\n";

                    if (isset($product_details['image']) && count($product_details['image'])>0){

            			foreach ($product_details['image'] as $image_fn => $value){

                            if (!file_exists($product_path.$image_fn)){continue;}

                            $image_mod_time=filemtime($product_path.$image_fn);

            				// check if correct size image exists and create one if it doesn't
            				$thumbnail_fn=$tn_size_x."x".$tn_size_y.'_'.$image_mod_time.'p'.$product_details['id'].'_'.safe_file_name($image_fn);
            				if (!file_exists(sys_image_dir.'/'.$thumbnail_fn) || filemtime(sys_image_dir.'/'.$thumbnail_fn)<=$image_mod_time){
            					createthumb($product_path.$image_fn,sys_image_dir.'/'.$thumbnail_fn,$tn_size_x,$tn_size_y,1,watermark_products);
            				}

                            if (!file_exists(sys_image_dir.'/'.$thumbnail_fn)){continue;}

                            // check if correct size main image exists and create one if it doesn't
                            $thumbnail_main_fn=$main_image_size_x."x".$main_image_size_y.'_'.$image_mod_time.'p'.$product_details['id'].'_'.safe_file_name($image_fn);
            				if (!file_exists(sys_image_dir.'/'.$thumbnail_main_fn) || filemtime(sys_image_dir.'/'.$thumbnail_main_fn)<=$image_mod_time){
            					createthumb($product_path.$image_fn,sys_image_dir.'/'.$thumbnail_main_fn,$main_image_size_x,$main_image_size_y,1,watermark_products);
            				}

                            // check if correct size zoom-in image exists and create one if it doesn't
                            $thumbnail_zoom_fn=$cms_settings['img']['zoom_width_tn']."x".$cms_settings['img']['zoom_height_tn'].'_'.$image_mod_time.'p'.$product_details['id'].'_'.safe_file_name($image_fn);
            				if (!file_exists(sys_image_dir.'/'.$thumbnail_zoom_fn) || filemtime(sys_image_dir.'/'.$thumbnail_zoom_fn)<=$image_mod_time){
            					createthumb($product_path.$image_fn,sys_image_dir.'/'.$thumbnail_zoom_fn,$cms_settings['img']['zoom_width_tn'],$cms_settings['img']['zoom_height_tn'],1,watermark_products);
            				}



            				// get size of thumbnail image
            				$image_size=getimagesize(sys_image_dir.'/'.$thumbnail_fn);

            				$link_title=$product_details['name'];
            				if (strlen($value['alt_tag'])>0 && $value['alt_tag']!=$product_details['name']){$link_title.=' - '.$value['alt_tag'];}

                            $image_content.="<a href=\"".cms_image_url.$thumbnail_main_fn."\"><img alt=\"".htmlentities($value['alt_tag'],ENT_COMPAT,'UTF-8')."\" src=\"".cms_image_url.$thumbnail_fn."\" data-big=\"".cms_image_url.$thumbnail_zoom_fn."\"/></a>\n";

                            // page meta for facebook
                            if (!isset($og_image)){
                                $og_image=1;

                                // image size should be minimum recommended by fb
                                // 1200x630 recommended - 600x315 recommended - 200x200 minimum
                                $og_tn_size_x=600;
                                $og_tn_size_y=315;
                                /*
                                // I do not know why I have this ratio  resize code - can't remember - createthumb handles ration resize anyway?
                                $image_size=getimagesize($product_path.$image_fn);
                                if ($image_size[0]>0 && $image_size[1]>0){
                                    $ratio=1.0;
                                    if ($image_size[1]<$image_size[0]){
                                        $ratio=$image_size[0]/$image_size[1];
                                    }
                                    elseif ($image_size[0]<$image_size[1]){
                                        $ratio=$image_size[1]/$image_size[0];
                                    }
                                    $og_tn_size_x=ceil($og_tn_size_x*$ratio);
                                    $og_tn_size_y=ceil($og_tn_size_y*$ratio);
                                }
                                */

                  				// check facebook sharing image exists and create one if it doesn't
                  				$og_thumbnail_fn=$og_tn_size_x."x".$og_tn_size_y.'_'.$image_mod_time.'p'.$product_details['id'].'_'.safe_file_name($image_fn);
                  				if (!file_exists(sys_image_dir.'/'.$og_thumbnail_fn)){
                  					createthumb($product_path.$image_fn,sys_image_dir.'/'.$og_thumbnail_fn,$og_tn_size_x,$og_tn_size_y,1,watermark_products);
                  				}

                                if (isset($og_thumbnail_fn)){

                                    $image_size=getimagesize(sys_image_dir.'/'.$og_thumbnail_fn);

                                    $og_data['image']=cms_image_url.$og_thumbnail_fn;
                                    $og_data['image_width']=$image_size[0];
                                    $og_data['image_height']=$image_size[1];

                                }

                            }

            			}

                    }

                    if (isset($product_details['youtube_video']) && strlen($product_details['youtube_video'])>0){
                        $image_content.="<a href=\"http://www.youtube.com/watch?v=".$product_details['youtube_video']."\"><span class=\"video\">Watch this video!</span></a>";
                    }

                    $image_content.="</div>";

                    // facebook og code
                    $og_data['title']=$product_details['name'];
                    if (isset($product_details['short_description']) && $product_details['short_description']!=''){$og_data['description']=htmlentities($product_details['short_description'],ENT_COMPAT,'UTF-8');}
                    $og_data['url']=item_url('product',$rvi_product,$product_details['slug']);

        		}



        // display image content
        if (isset($image_content)){$page_content['main'].=$image_content;}

        $page_content['main'].="<div class=\"main_content\"><h1>".htmlentities($product_details['name'],ENT_COMPAT,'UTF-8')."</h1>";
        if (strlen($product_details['code'])>0){$page_content['main'].="<div class=\"product_code\">(".htmlentities($product_details['code'],ENT_COMPAT,'UTF-8').")</div>";}

		// format display price
        $display_price='';
		if ($product_details['price']==0 && strlen($product_details['price_text'])>0){$display_price=$product_details['price_text'];}
		elseif ($product_details['price']>0){
            if ($cms_settings['b2b']>0){$display_price=currency_symbol.number_format($product_details['price_net'],2);}
            else{$display_price=currency_symbol.number_format($product_details['price'],2);}
            if ($cms_settings['b2b']>0 && $product_details['tax_rate']>0){$display_price.=' <span class=\"product_price_text\">(Excl. Tax)</span>';}
  			if (strlen($product_details['price_text'])>0){
  				$display_price.=" <span class=\"product_price_text\">".$product_details['price_text']."</span>";
  			}
		}

	    // output product options if there are any
        $product_options='';
  		if (isset($product_details['option'])){

  			$product_options.="<div style=\"margin: 5px 0\">";
  			foreach ($product_details['option'] as $option_name => $value){

                  if (count($value)==1 && key($value)==''){
                      $product_options.="<div class=\"form_row\"><label for=\"opt_".$option_name."\">".$option_name.":</label><input type=\"text\" id=\"opt_".$option_name."\" name=\"product_option[".$option_name."]\" value=\"\" /></div>";
                  }
                  else{
                      $option_content='';
      				foreach ($value as $value_name => $value2){
                          if ($value_name==''){continue;}
      					$display_value=$value_name;

  			            // displaying price modifiers beside the value
                          if  ($value2['price_mod_value']!=0){
                              if ($value2['price_mod']==0){
      					        if ($value2['price_mod_value']>0){$display_value=$value_name." ( + ".currency_symbol.number_format($value2['price_mod_value'],2)." )";}
      					        elseif ($value2['price_mod_value']<0){$display_value=$value_name." ( - ".currency_symbol.number_format(str_replace('-','',$value2['price_mod_value']),2)." )";}
                              }
                              elseif($value2['price_mod']==1 && $value2['price_mod_value']>0){
                                  $display_value=$value_name." ( ".currency_symbol.number_format($value2['price_mod_value'],2)." )";
                              }
                          }
      					$option_content.='<option value="'.$value_name.'">'.$display_value.'</option>';
      				}
                      if (strlen($option_content)>1){
      			    	$product_options.="<div class=\"form_row\"><label for=\"opt_".$option_name."\">".$option_name.":</label><select id=\"opt_".$option_name."\" name=\"product_option[".$option_name."]\">".$option_content."</select></div>";
                      }
                  }

  			}
  			$product_options.="</div>";
  		}

        if (substr($product_details['behaviour'],0,7)=='Listing'){

            // product option fields should be output within the listing submission form and not here
            // product content and display price should also be output within the listing file for more flexibilty
            //if ($display_price!=''){$page_content['main'].='<div class="product_price">'.$display_price.'</div>';}
            //if (isset($product_details['content']['main']) && $product_details['content']['main']!=''){$page_content['main'].="<div class=\"product_description\">".$product_details['content']['main']."</div>";}

            $add_listing_fn=cms_theme_dir.'includes/listing_add_'.substr($product_details['behaviour'],8).'.php';
            if (file_exists($add_listing_fn)){include($add_listing_fn);}
            else{$page_content['main'].='Error: File not found';}
        }
        elseif(substr($product_details['behaviour'],0,11)=='Application'){

            // product option fields should be output within the appliation submission form and not here
            // product content and display price should also be output within the application file for more flexibilty
            //if ($display_price!=''){$page_content['main'].='<div class="product_price">'.$display_price.'</div>';}
            //if (isset($product_details['content']['main']) && $product_details['content']['main']!=''){$page_content['main'].="<div class=\"product_description\">".$product_details['content']['main']."</div>";}

            $add_application_fn=cms_theme_dir.'includes/application_add_'.substr($product_details['behaviour'],12).'.php';
            if (file_exists($add_application_fn)){include($add_application_fn);}
            else{$page_content['main'].='Error: File not found';}
        }
        else{

            if ($display_price!=''){$page_content['main'].='<div class="product_price">'.$display_price.'</div>';}

    		$page_content['main'].='<form method="post" class="product" action="#productform" enctype="multipart/form-data" id="productform">';

            $page_content['main'].=$product_options;

    		// display add to cart button if enabled
            if ($product_details['status']==1){
                if (!isset($rvi_qty)){$rvi_qty=1;}
        		if ($product_details['behaviour']=='Add to Cart' && $product_details['note_form_enabled']<1 && $product_details['file_upload_enabled']<1){

                    $page_content['main'].="<div class=\"product_buy\">";
                    if ($product_details['subscription']>0){
                        $page_content['main'].="<input type=\"hidden\" name=\"qty\" value=\"0\" /> ";
                    }else{$page_content['main'].="<span class=\"product_qty\">Qty: <input type=\"text\" name=\"qty\" value=\"$rvi_qty\" /></span> ";}
                    //$page_content['main'].="<input type=\"hidden\" name=\"add_to_cart\" value=\"".$rvi_product."\" /><input type=\"image\" src=\"".display_theme_file_loc('images/shop/add_to_cart.png',1)."\" style=\"vertical-align: middle; padding-left: 5px\" /></div>";
                    $page_content['main'].="<input type=\"hidden\" name=\"add_to_cart\" value=\"".$rvi_product."\" /><button type=\"submit\" class=\"btn btn_add_to_cart\">".$txt['btn_add_to_cart']."</button></div>";
        		}

                // we want to include add to cart popup
                // no longer needed as cms_front now checks all content areas for add_to_cart and includes popup if found
                // if ($product_details['behaviour']=='Add to Cart' && $product_details['note_form_enabled']<1 && $product_details['file_upload_enabled']<1){$include_cart_popup=1;}

            }else{$page_content['main'].="<div class=\"outofstock\">Out of Stock</div>";}

    		if (isset($product_details['content']['main']) && $product_details['content']['main']!=''){$page_content['main'].="<div class=\"product_description\">".$product_details['content']['main']."</div>";}

  		    // display checkout warnings
  		    if (isset($_SESSION['form']['product_detail']['warning'])){$page_content['main'].=display_warnings($_SESSION['form']['product_detail']['warning']);}

    		// display note form
    		if ($product_details['behaviour']=='Add to Cart' && $product_details['note_form_enabled']>0){
                $page_content['main'].="<div style=\"margin: 20px 0\"><h3>Order Notes</h3>";
                if ($product_details['note_form_enabled']>1){$page_content['main'].="<p>Use the text box below to provide required text/special instructions when ordering this product.</p>";}
                else{$page_content['main'].="<p>Use the text box below to provide any notes or special instructions when ordering this product.</p>";}
                $page_content['main'].="<textarea name=\"customer_note\" cols=\"30\" rows=\"5\">".(isset($rvi_customer_note) ? $rvi_customer_note : "")."</textarea>";
                $no_scpu=1; // no shopping cart popup
                $page_content['main'].="</div>";
    		}

    		// display file upload form
    		if ($product_details['behaviour']=='Add to Cart' && $product_details['file_upload_enabled']>0){
    			$page_content['main'].="<div style=\"margin: 20px 0\"><h3>Upload File</h3><p>Upload a file for this product.</p><input type=\"file\" name=\"uploaded_file\" /><p>Please allow time for your image to upload when adding to cart.</p>";
                $no_scpu=1; // no shopping cart popup
                $page_content['main'].="</div>";
    		}

    		// display add to cart button if enabled
            if ($product_details['status']==1){

                if (isset($no_scpu)){$page_content['main'].="<input type=\"hidden\" name=\"no_scpu\" value=\"1\" />";}

        		if ($product_details['behaviour']=='Add to Cart' && ($product_details['note_form_enabled']>0 || $product_details['file_upload_enabled']>0)){
        			$page_content['main'].="<div class=\"product_buy\">";
                    if ($product_details['subscription']>0){
                        $page_content['main'].="<input type=\"hidden\" name=\"qty\" value=\"0\" /> ";
                    }else{$page_content['main'].="<span class=\"product_qty\">Qty: <input type=\"text\" name=\"qty\" value=\"$rvi_qty\" /></span> ";}
                    //$page_content['main'].="<input type=\"hidden\" name=\"add_to_cart\" value=\"".$rvi_product."\" /><input type=\"image\" src=\"".display_theme_file_loc('images/shop/add_to_cart.png',1)."\" style=\"vertical-align: middle; padding-left: 5px\" /></div>";
                    $page_content['main'].="<input type=\"hidden\" name=\"add_to_cart\" value=\"".$rvi_product."\" /><button type=\"submit\" class=\"btn btn_add_to_cart\">".$txt['btn_add_to_cart']."</button></div>";

        		}
            }

            $page_content['main'].='</form>';

    		// display enquiry form
    		if ($product_details['enquiry_form_enabled']=='1'){

    			$page_content['main'].="<hr /><h3>Enquire about ".$product_details['name']."</h3>";

                $subject="Product enquiry - ".$product_details['name'];
                include(cms_root_dir.'includes/contact_form.php');
                $page_content['main'].=$contact_form;
    		}
        }

        // close product detail main content div
        $page_content['main'].='</div>';

        // close product detail div
        $page_content['main'].='</div>';

  		// display related products
  		if (isset($product_details['related_product'])){
  			$category_details=get_category_details(2);
  			$page_output=display_category($category_details,1,null,$product_details['related_product']);
  		   	$page_content['main'].="<hr />".$page_output['content']['main'];
  		}

  		// add to recently viewed items
  		if (!isset($_SESSION['recently_viewed_products'][$rvi_product])){$_SESSION['recently_viewed_products'][$rvi_product]['priority']=1;}
  		else{$_SESSION['recently_viewed_products'][$rvi_product]['priority']++;}

        // save cached page content
        // caching product page not worthwhile ?
        /*
        if (cache_enabled>0 && $no_cache<1){
            $fo=fopen($cache_fn,'w');
            fwrite($fo,$page_content['main']."|cache|".$page_meta."|cache|".$page_end);
            fclose($fo);
        }
        */

	}else{include(cms_root_dir.'includes/page_not_found.php');}


?>
