<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}

	// set page title
	$page_title=$txt['Checkout']." - ".$txt['Shipping'];

    if (!isset($_SESSION['checkout']['shipping_total'])){$_SESSION['checkout']['shipping_total']=0;}

    // skip shipping if all ordered products are subscriptions - in future change this to check for all behaviours add to cart - no shipping
    // maybe a shipping address needed for subscriptions, eg. posted magazine sub - needs to be replaced to check a specific product setting for (digital service/deliverable good)
    /*
    $all_products_no_shipping=1;
    if (isset($_SESSION['cart']['products']) && count($_SESSION['cart']['products'])>0){
        foreach($_SESSION['cart']['products'] as $product_option_id => $product){
            if (!isset($_SESSION['cart']['products'][$product_option_id]['subscription']) || $_SESSION['cart']['products'][$product_option_id]['subscription']<=0){$all_products_no_shipping=0;break;}
        }
    }
    if ($all_products_no_shipping>0){
        if (isset($_SESSION['checkout']['shipping_option'])){unset($_SESSION['checkout']['shipping_option']);}
        $_SESSION['checkout']['shipping_total']=0;
        $_SESSION['order_stage']="confirm_order";include("confirm_order.php");return;
    }
    */

    // get active shipping options into array
    $shipping_options_dir=cms_root_dir.'includes/shop/shipping_options';
    if ($handle=opendir($shipping_options_dir)){
      while (false!==($file=readdir($handle))){
          if ($file!='.' && $file!='..' && is_dir($shipping_options_dir.'/'.$file) && substr($file,0,1)!='_'){
                $shipping_option_fn=$shipping_options_dir.'/'.$file.'/shipping_option.php';
                if (file_exists($shipping_option_fn)){
                    $shipping_option_details=array(); // make sure this array is cleared
                    include($shipping_option_fn);
                    if (isset($shipping_option_details['status']) && $shipping_option_details['status']>0){
                        // only show shipping option if it is enabled or in testmode and main admin user
                        if ($shipping_option_details['status']==1 || admin_level()>9){
                            $shipping_options[$file]=$shipping_option_details;
                        }
                    }
                }
          }
      }
    }


    // if no shipping options go to confirm order
    if (empty($shipping_options)){
        if (isset($_SESSION['checkout']['shipping_option'])){unset($_SESSION['checkout']['shipping_option']);}
        $_SESSION['order_stage']="confirm_order";include("confirm_order.php");return;
    }

    $shipping_option_count=count($shipping_options);

    // if only one active shipping option is available apply it and go to confirm order
    if ($shipping_option_count==1){
        $calc_shipping=1;
        foreach ($shipping_options as $shipping_option_fn => $value){
            $shipping_option_details=array(); // make sure this array is cleared
    		include($shipping_options_dir.'/'.$shipping_option_fn.'/shipping_option.php'); // we know file exists as we just pulled it into $shipping_options array
            if (!empty($shipping_option_details)){
                $_SESSION['checkout']['shipping_option']=$shipping_option_details;
                // strip any underscores used in the name for manual sorting
                $_SESSION['checkout']['shipping_option']['name']=str_replace('_','',$shipping_option_details['name']);
            }
        }
		if (isset($shipping_total)){$_SESSION['checkout']['shipping_total']=$shipping_total;}
        $_SESSION['order_stage']="confirm_order";include("confirm_order.php");return;
    }

    uasort($shipping_options,'compare_items_names');

    $display_shipping_options="";
    if (isset($shipping_options)){

        foreach ($shipping_options as $shipping_option_fn => $value){

            // strip any underscores used in the name for manual sorting
            $shipping_name=str_replace('_','',$value['name']);
            $shipping_name=stripslashes($shipping_name);

            if (isset($_SESSION['checkout']['shipping_option']['id']) && $_SESSION['checkout']['shipping_option']['id']==$value['id']){$checked="checked=\"checked\"";}else{$checked="";}
            $display_shipping_options.="<div class=\"shipping_option\"><input type=\"radio\" id=\"so_".$value['id']."\" class=\"shipping_option_radio\" name=\"shipping_option\" value=\"".$value['id']."\" ".$checked."/><div><h2 class=\"shipping_option_name\">".$shipping_name."</h2><div class=\"shipping_option_description\">".stripslashes($value['description'])."</div>";
            if (isset($value['form']) && $value['form']!=""){$display_shipping_options.="<div style=\"margin-top: 10px\">".$value['form']."</div>";}
            $display_shipping_options.="</div></div>\n";

        }

    }

	// check for continue button
	if(isset($rvi_continue_to_confirm)){

		if (!isset($rvi_shipping_option)){$_SESSION['form']['shipping']['warning'][]="Please choose a shipping option";}

		if(!isset($_SESSION['form']['shipping']['warning'])){

        	$shipping_option_fn=$shipping_options_dir.'/'.$rvi_shipping_option.'/shipping_option.php';
        	if (file_exists($shipping_option_fn)){
                $calc_shipping=1;
        		include($shipping_option_fn);
                if (isset($shipping_option_details)){$_SESSION['checkout']['shipping_option']=$shipping_option_details;}
        		if (isset($shipping_total)){$_SESSION['checkout']['shipping_total']=$shipping_total;}

                // strip any underscores used in the name for manual sorting
                $_SESSION['checkout']['shipping_option']['name']=str_replace('_','',$shipping_option_details['name']);

                if (isset($rvi_user_shipping_info[$shipping_option_details['id']])){

                    foreach ($rvi_user_shipping_info[$shipping_option_details['id']] as $name => $value){
                        $_SESSION['checkout']['shipping_option']['user_shipping_info'][$name]=$value;
                    }

                }


        	}

			$_SESSION['order_stage']="confirm_order";include("confirm_order.php");return;

		}
	}

	
	// show shipping page
    $page_content['main'].="<fieldset><legend>".$txt['Shipping']."</legend><p>".$txt['Shipping_message']."</p>\n";

    // display warnings
    if (isset($_SESSION['form']['shipping']['warning'])){$page_content['main'].=display_warnings($_SESSION['form']['shipping']['warning']);}


    $page_content['main'].="<form name=\"shipping_form\" method=\"post\" action=\"".cms_url."?order_stage=shipping\">
    <div class=\"shipping_options\">";

    // display active shipping options
    $page_content['main'].=$display_shipping_options;

    $page_content['main'].="<div class=\"form_row_footer\"><button type=\"submit\" name=\"continue_to_confirm\" class=\"btn btn_checkout\">".$txt['btn_continue']."</button></div>
        </div></form></fieldset>";

    $jquery_required=1;
    $page_end.="<script>
    $( document ).ready(function() {
        $('.shipping_option').on('click', '*', function(e) {

            $('.shipping_option').removeClass('shipping_option_highlight');
            var active_shipping_option = $(e.target).closest('.shipping_option');
            active_shipping_option.addClass('shipping_option_highlight');

            $('input[type=radio]:first', active_shipping_option).prop('checked', true);

        });
    });
    </script>";

?>