<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}

	// set page title
	if ($page_title==''){$page_title.=cms_site_name.' - Forgottten Password';}

	if (isset($_POST['fp_email'])){

        $fp_email=trim($_POST['fp_email']);

        $_SESSION['form']['forgot_password']['email']=$fp_email;

		// check values
		require(cms_root_dir."scripts/emailval.php");
		if (strlen($fp_email)<4 || strlen($fp_email)>200 || MailVal($fp_email,2)){$_SESSION['form']['forgot_password']['warning'][]=$txt['Warning_enter_registered_email'];}

		if (!isset($_SESSION['form']['forgot_password']['warning'])){
          // check user list file for email and password match
			if ($users=get_items('customers',null,null,null,null,null,null,null,array('email'))){

                // case-insensitive check on user acccount emails
                $fp_email=strtolower($fp_email);

		        $customer_count=count($users);
                for ($item_num=0; $item_num<$customer_count; $item_num++){
					// if login details match log user in
					if (strtolower($users[$item_num]['email'])==$fp_email){
						if ( $user_details=get_item_details('customer',$users[$item_num]['id'])){
                            $account_found=$user_details;
						}
						break;
					}
				}
			}

            // check if email matches main admin only check this from backend view
            if (cms_interface=="back" && !isset($account_found) ){
                if (strtolower($cms_settings['config']['admin_email'])==$fp_email){
                    $account_found['id']=0;
                    $account_found['email']=$cms_settings['config']['admin_email'];
                }
            }

            // send reset password email if account found
            if (isset($account_found)){

               	require_once(cms_root_dir.'plugins/PHPMailer/class.phpmailer.php');

                $mail = new PHPMailer();

                // send mail via smtp if set in config file
                if (defined('smtp_host')){
                    $mail->IsSMTP(); // send via SMTP
                    $mail->SMTPAuth = true; // turn on SMTP authentication
                    $mail->SMTPSecure = 'ssl';
                    $mail->Username = smtp_username; // SMTP username
                    $mail->Password = smtp_password; // SMTP password
                    $mail->Host       = smtp_host; // SMTP server
                    $mail->Port       = smtp_port; // SMTP server
                }

                // send confirmation email to user
                $mail->From = $cms_settings['config']['site_email'];
                $mail->FromName = cms_site_name;
                $mail->AddAddress($account_found['email']);
                $mail->AddReplyTo($cms_settings['config']['site_email'], cms_site_name);

                $mail->Subject = cms_site_name." - Password Reset";

                if ($account_found['id']==0){$mail->Body    = "Hi ,\n\nA request was made to reset the admin password for your website. If you did not issue this request then please ignore this email.\n\nTo reset the password please click on the link below. You can also copy and paste this link into your browsers address bar.\n\n".admin_resetpass_link()."\n\n\n".cms_site_name."\n".cms_site_url;}
                else{$mail->Body    = "Hi ".$account_found['name'].",\n\nA request was made to reset your password. If you did not issue this request then please ignore this email.\n\nTo reset your password please click on the link below. You can also copy and paste this link into your browsers address bar.\n\n".user_resetpass_link($account_found)."\n\n\n".cms_site_name."\n".cms_site_url;}

                if($mail->Send()){
                    $_SESSION['form']['forgot_password']['warning_green'][]=$txt['Forgot_password_submitted'];
                    if ($account_found['id']>0){update_item_log('user',$account_found['id'],'Reset password email sent to '.short_name($account_found['name'],2).' '.$account_found['id']);}
                    else{update_log("Reset admin password email sent");}
                }
                else{
                    if ($account_found['id']>0){update_item_log('user',$account_found['id'],'Sending Failed: Reset password email to '.short_name($account_found['name'],2).' '.$account_found['id']);}
                    else{update_log("Warning: Reset admin password email failed to send");}
                }

            }
			else{
                $_SESSION['form']['forgot_password']['warning'][]=$txt['Warning_account_not_found']." ".$txt['Warning_enter_registered_email'];
                sleep(3); // anti-brute-force measure on failed email lookup
            }

		}

        // redirect after form submit so browser back and refresh work without browser resend form data warning
        header('HTTP/1.1 303 See Other');
        header("Location: ".cms_url."?forgot_password");
        exit();

	}


	// display customer login form
    if (isset($_SESSION['form']['forgot_password']['warning_green'])){$page_content['main'].=display_warnings($_SESSION['form']['forgot_password']['warning_green'],'green');}
    else {

        // display warnings
        if (isset($_SESSION['form']['forgot_password']['warning'])){$page_content['main'].=display_warnings($_SESSION['form']['forgot_password']['warning']);}

        // login links
        $login_links[]="<a href=\"".cms_url."?login\">".$txt['Login']."</a>";
        if (!isset($cms_settings['users']['close_registration']) || $cms_settings['users']['close_registration']<1){$login_links[]="<a href=\"".cms_url."?register\">".$txt['Register']."</a>";}

		$page_content['main'].="<form id=\"forgot_password_form\" class=\"cms_form\" name=\"password_reminder_form\" method=\"post\" action=\"#forgot_password_form\" style=\"max-width:500px\">
        <fieldset><legend>Forgot Password</legend>
        <p>".$txt['Forgot_password_instruction']."</p>
		<div class=\"form_row\"><label>".$txt['Email'].":</label><input type=\"text\" name=\"fp_email\" value=\"".(isset($_SESSION['form']['forgot_password']['email']) ? $_SESSION['form']['forgot_password']['email'] : "")."\" class=\"input_default\"></div>
		<div class=\"form_row_footer\">".link_str($login_links,"<span class=\"linkstr_seperator\">|</span>")."<span class=\"linkstr_seperator\">|</span><button type=\"submit\" class=\"btn btn_login\">".$txt['btn_submit']."</button></div>
        </fieldset>
		</form>";
	}


?>
