<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}
	
	// set page title
	if ($page_title==''){$page_title.=cms_site_name." - ".$txt['Register'];}


	$page_content['main'].="<a id=\"registration_form\"></a><h1>".$txt['Register']."</h1>";


    if (isset($cms_settings['users']['close_registration']) && $cms_settings['users']['close_registration']>0){$page_content['main'].="<p>".$txt['Warning_registration_closed']."</p>";return;}


	if (isset($rvi_create_account)){

		// clean input values
		$rvi_name=sanitize_text_input($rvi_name);
		$rvi_email=trim($rvi_email);

		// check values
		if (strlen($rvi_name)<2 || strlen($rvi_name)>100){$_SESSION['form']['register']['warning'][]=$txt['Warning_enter_name'];}
		require(cms_root_dir."scripts/emailval.php");
		if (strlen($rvi_email)<4 || strlen($rvi_email)>200 || MailVal($rvi_email,2)){$_SESSION['form']['register']['warning'][]=$txt['Warning_enter_email'];}
		elseif (email_registered($rvi_email)){$_SESSION['form']['register']['warning']=array($txt['Warning_email_registered']);}


        if (isset($cms_settings['users']['security_answer']) && $cms_settings['users']['security_answer']!=""){
            $rvi_security_answer=trim(strtolower($rvi_security_answer));
            if ($rvi_security_answer!=trim(strtolower($cms_settings['users']['security_answer']))){$_SESSION['form']['register']['warning'][]='Please answer the anti-spam security question correctly.';}
        }

		if (isset($_SESSION['form']['register']['warning'])){
		    $_SESSION['form']['name']=$rvi_name;
		    $_SESSION['form']['email']=$rvi_email;
            if (isset($rvi_newsletter)){$_SESSION['form']['newsletter']=$rvi_newsletter;}
            if (isset($rvi_no_email)){$_SESSION['form']['no_email']=$rvi_no_email;}
        }
        else{

			$time=time();
			// create customer id and check it does not already exist
			$check_customer=TRUE;
			while($check_customer==TRUE){
				$customer_id=$time.rand(100,999);
				if (get_item_details('customer',$customer_id)==FALSE){$check_customer=FALSE;}
			}
			
			// save customer details
            $customer_details['item_type']='customer';
			$customer_details['id']=$customer_id;
            $customer_details['verified']='0';

            // generate a random password
            $password=generate_password();
            $customer_details['password']=encrypt_password($password,$customer_details['id']);

            $customer_details['status']='1';
			$customer_details['registered_timestamp']=$time;
			if (isset($_SESSION['referrer'])){$customer_details['referrer']=$_SESSION['referrer'];}
			$customer_details['name']=$rvi_name;
			$customer_details['email']=$rvi_email;
            if (isset($rvi_newsletter)){$customer_details['newsletter_subscription']='yes';}else{$customer_details['newsletter_subscription']='no';}
            $customer_details['phone']='';
            $customer_details['dob_day']='---';
            $customer_details['dob_month']='---';
            $customer_details['dob_year']='---';

            $customer_details['address']='';
            $customer_details['address_2']='';
            $customer_details['city']='';
            $customer_details['postcode']='';
            $customer_details['country']='---';
            $customer_details['county']='';

			save_item_details($customer_details);
            update_item_list_file('customers',array($customer_details['id']),'add');

            update_item_log('user',$customer_details['id'],'New user account registered - '.$customer_details['name'].' '.$customer_details['id']);

            if (!isset($rvi_no_email)){

    			require_once(cms_root_dir.'plugins/PHPMailer/class.phpmailer.php');

    			$mail = new PHPMailer();

                // send mail via smtp if set in config file
                if (defined('smtp_host')){
                    $mail->IsSMTP(); // send via SMTP
                    $mail->SMTPAuth = true; // turn on SMTP authentication
                    $mail->SMTPSecure = 'ssl';
                    $mail->Username = smtp_username; // SMTP username
                    $mail->Password = smtp_password; // SMTP password
                    $mail->Host       = smtp_host; // SMTP server
                    $mail->Port       = smtp_port; // SMTP server
                }

    			// send confirmation email to user
    			$mail->From = $cms_settings['config']['site_email'];
    			$mail->FromName = cms_site_name;
    			$mail->AddAddress($rvi_email);

    			$mail->Subject = cms_site_name." - New Account Registration";
    			$mail->Body    = "Hi $rvi_name,\n\nThank you for registering with ".cms_site_name." - Your new login password is ".$password."\n\nClick on the link below to verify your account and login.\n\n".user_login_link($customer_details)."\n\nThis is an automated email; if you received it in error, no action is required.\n\n".cms_site_name."\n".cms_site_url;

    			if($mail->Send()){

                    update_item_log('user',$customer_details['id'],'Registration email sent to '.$customer_details['name'].' '.$customer_details['id']);
    				$_SESSION['form']['register']['warning_green'][]="<h2>".$txt['Thank_You']."</h2><p>".$txt['Registration_submitted_text']."</p>";
    			}
                else{
                    if (defined('smtp_host')){update_item_log('user',$customer_details['id'],'Sending failed via smtp '.smtp_host.' of registration email to user '.$customer_details['id']);}
                    else {update_item_log('user',$customer_details['id'],'Sending failed of Registration email to user '.$customer_details['id']);}
                }


            }else{

                    $_SESSION['form']['register']['warning_green'][]="<h2>".$txt['Thank_You']."</h2>
    				<p>".$txt['New_account_registered']."</p>";
            }
		
		}
	
	    // redirect after form submit so browser back and refresh work without browser resend form data warning
        header('HTTP/1.1 303 See Other');
        header("Location: ".cms_url."?register");
        exit();

	
	}

 
	// display consumer registration form
    if (isset($_SESSION['form']['register']['warning_green'])){$page_content['main'].=display_warnings($_SESSION['form']['register']['warning_green'],'green');}
    else{

        // login links
        $login_links[]="<a href=\"".cms_url."?login\">".$txt['Login']."</a>";
        $login_links[]="<a href=\"".cms_url."?forgot_password\">".$txt['Forgot_Password']."</a>";

		$page_content['main'].="<p>".$txt['account_register']." ".link_str($login_links," / ")."</p>";

        // display warnings
        if (isset($_SESSION['form']['register']['warning'])){$page_content['main'].=display_warnings($_SESSION['form']['register']['warning']);}
	
		$page_content['main'].="
		<form class=\"cms_form\" name=\"customer_registation_form\" method=\"post\" action=\"#registration_form\">
		<table class=\"basic_table\"><tbody>
		<tr><td>".$txt['Name'].": </td><td><input type=\"text\" name=\"name\" value=\"".(isset($_SESSION['form']['name']) ? $_SESSION['form']['name'] : '')."\" /></td></tr>
		<tr><td>".$txt['Email'].": </td><td><input type=\"text\" name=\"email\" value=\"".(isset($_SESSION['form']['email']) ? $_SESSION['form']['email'] : '')."\" /></td></tr>
        <tr><td colspan=\"2\" class=\"small_note\"><input type=\"checkbox\" name=\"newsletter\" ".(isset($_SESSION['form']['newsletter']) ? 'checked="checked" ' : '')." /> ".$txt['Newsletter_sub_instruction']."</td></tr>";

        if (admin_level()>9){
            $page_content['main'].="<tr><td colspan=\"2\" class=\"small_note\"><hr /><b>Admin Controls</b> - You are logged in as administrator (<a href=\"".cms_url."?logout\">".$txt['Logout']."</a>)<br /><input type=\"checkbox\" name=\"no_email\" ".(isset($_SESSION['form']['no_email']) ? 'checked="checked" ' : '')." /> Do not send account registration email to user</td></tr>";
        }

        if (isset($cms_settings['users']['security_question']) && $cms_settings['users']['security_question']!="" && $cms_settings['users']['security_answer']!=""){

          $page_content['main'].="<tr>
            <td colspan=\"2\"><hr /><p class=\"small_note\">Please answer the question below to verify you're not a spam-bot.</p>
            <span class=\"small_note\"><b>".$cms_settings['users']['security_question']."</b> <input type=\"text\" name=\"security_answer\" value=\"".(isset($rvi_security_answer) ? $rvi_security_answer : "")."\" /></td>
          </tr>";

        }


		//$page_content['main'].="<tr><td colspan=\"2\" style=\"text-align: right\"><input type=\"hidden\" name=\"create_account\" /><input type=\"image\" src=\"".display_theme_file_loc('images/users/register.png',1)."\" style=\"vertical-align: middle; padding-left: 5px\" alt=\"Register\" /></td></tr>";
        $page_content['main'].="<tr><td colspan=\"2\" style=\"text-align: right\"><input type=\"hidden\" name=\"create_account\" /><button type=\"submit\" class=\"btn btn_login\">".$txt['btn_register']."</button></td></tr>";
        $page_content['main'].="</tbody></table>
		</form>";
	}


?>
