<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}

    $rvi_subject=cms_site_name." - Order Ref: ".$order_details['id'];

    $status_options=array('Unpaid','Paid','Paid & Processed','Cancelled','Pending');

    if (!isset($rvi_mail_body)){$rvi_mail_body="Hi ".short_name($user_details['name']).",\n\n";}

/*
    if ($order_details['status']<1){
        // unpaid
        $rvi_mail_body.="Thank you for your recent order.\n\nYou can view the invoice for this order by logging into your account using the link below.\n\n".user_login_link($user_details,"?myaccount&order=".$order_details['id'])."\n\nIf you have not yet made payment and would like to do so now please go to\n".cms_url."?paynow=".$order_details['id'];
    }
    */

    $invoice_age_days=0;
    if (isset($order_details['date']) && $order_details['date']>0){$invoice_age_days=(time()-$order_details['date'])/86400;}

    if (isset($order_details['due_date']) && $order_details['due_date']>0){$overdue_days=(time()-$order_details['due_date'])/86400;}else{$overdue_days=0;}

    if ($order_details['status']<1 && $overdue_days>1){
        // unpaid - overdue
        $rvi_subject=cms_site_name." - Overdue Invoice ".$order_details['id'];
        $rvi_mail_body.="Invoice ".$order_details['id']." dated ".date("d/m/y",$order_details['date'])." is now ".floor($overdue_days)." days overdue.\n\nTo view and pay this invoice please click the link below.\n\n".user_login_link($user_details,"?myaccount&order=".$order_details['id']);
    }
    elseif ($order_details['status']<1 && $invoice_age_days>10){
        // unpaid - more than 10 days old - reminder
        $rvi_subject=cms_site_name." - Invoice ".$order_details['id'];
        $rvi_mail_body.="This is a courtesy email to remind you of order invoice ".$order_details['id'];
        if (isset($order_details['date']) && $order_details['date']>0){$rvi_mail_body.=" dated ".date("d/m/y",$order_details['date']);}
        $rvi_mail_body.=".\n\nTo view and pay this invoice please click the link below.\n\n".user_login_link($user_details,"?myaccount&order=".$order_details['id']);
    }
    elseif ($order_details['status']<1){
        // unpaid
        $rvi_subject=cms_site_name." - Invoice ".$order_details['id'];
        $rvi_mail_body.="This is a courtesy email to notify you of order invoice ".$order_details['id'];
        if (isset($order_details['date']) && $order_details['date']>0){$rvi_mail_body.=" dated ".date("d/m/y",$order_details['date']);}
        $rvi_mail_body.=".\n\nTo view and pay this invoice please click the link below.\n\n".user_login_link($user_details,"?myaccount&order=".$order_details['id']);
    }
    elseif ($order_details['status']==1){
        // paid
        $rvi_mail_body.="This is a courtesy email to notify you that payment for order ".$order_details['id']." has been received and your order is now being processed.\n\nYou can view the invoice for this order by logging into your account using the link below.\n\n".user_login_link($user_details,"?myaccount&order=".$order_details['id'])."\n\nThank you for your custom.";
    }
    elseif ($order_details['status']==2){
        // paid and processed
        $rvi_mail_body.="This is a courtesy email to notify you that your order ".$order_details['id']." has been processed.\n\nYou can view the invoice for this order by logging into your account using the link below.\n\n".user_login_link($user_details,"?myaccount&order=".$order_details['id'])."\n\nThank you for your custom.";
    }
    elseif ($order_details['status']==3){
        // cancelled
        $rvi_mail_body.="This is a courtesy email to notify you that your order ".$order_details['id']." has been cancelled.";
    }
    elseif ($order_details['status']==4){
        // pending order - generated automatically via listing/sub renewals and not listed to user in their account area
        $rvi_mail_body.="This is a courtesy email to notify you that a pending invoice has been generated for your order ".$order_details['id']."\n\nYou can view the invoice for this order by logging into your account using the link below.\n\n".user_login_link($user_details,"?myaccount&order=".$order_details['id']);
    }
    elseif ($order_details['status']==5){
        // purchase order
        $rvi_mail_body.="This is a courtesy email to notify you of purchase order #".$order_details['id']."\n\nYou can view this order by logging into your account using the link below.\n\n".user_login_link($user_details,"?myaccount&order=".$order_details['id']);
    }
    elseif ($order_details['status']==6){
        // pro-forma invoice
        $rvi_mail_body.="This is a courtesy email to notify you of pro-forma invoice #".$order_details['id']."\n\nYou can view this pro-forma invoice by logging into your account using the link below.\n\n".user_login_link($user_details,"?myaccount&order=".$order_details['id']);
    }
    else{
        // default
        $rvi_mail_body.="Thank you for your recent order.\n\nYour order ".$order_details['id']." status is ".$status_options[$order_details['status']];
    }

    $rvi_mail_body.="\n\n".cms_site_name."\n".cms_site_url;

    // privacy policy note
    $rvi_mail_body.="\n\n------------------------------------\nFor information on how we collect and use your data please read our privacy policy at ".cms_url."?terms#privacy";

?>
