<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}

    if (!isset($rvi_mail_body)){$rvi_mail_body="Hi ".short_name($user_details['name']).",\n\n";}

    $subscription_name_text="Subscription Ref: ".$subscription_details['id']."\n";
    $subscription_name_text.=$subscription_details['name']."\n";
    if (isset($subscription_details['product']['option'])){
        foreach ($subscription_details['product']['option'] as $option => $value){
            $subscription_name_text.=$option.": ".$value."\n";
        }
        $subscription_name_text.="\n";
    }
    if (isset($subscription_details['product']['customer_note']) && $subscription_details['product']['customer_note']!=''){
        $subscription_name_text.=$subscription_details['product']['customer_note']."\n";
    }
    if ($subscription_details['start_time']>0){
        $subscription_age=time()-$subscription_details['start_time'];
        $expire_time=$subscription_details['start_time']+($subscription_details['days']*86400);
        $expire_days_left=($expire_time-time())/86400;
        $expire_date=date("d/m/y",$expire_time);
        $subscription_name_text.='Expires: '.$expire_date;
    }
    $subscription_name_text.="\n-------------\n";


    if ($subscription_details['status']<1 && $subscription_details['start_time']<1){
        // new and inactive
        $rvi_subject=cms_site_name.' - Activate Subscription';

        $rvi_mail_body.="A subscription on your account is awaiting activation:\n\n-------------\n".$subscription_name_text."\nPlease use the link below to login and renew/activate the subscription..\n\n".user_login_link($user_details,"?myaccount=subscriptions");

    }
    elseif ($subscription_details['status']==1 && ($subscription_age<259200 || $expire_days_left>300)){
        // new and active
        $rvi_subject=cms_site_name.' - New subscription active';

        $rvi_mail_body.="This is a courtesy email to notify you that your subscription ref: ".$subscription_details['id']." is now active.\n\n-------------\n".$subscription_name_text."\nYou can use the link below to login and review your subscriptions.\n\n".user_login_link($user_details,"?myaccount=subscriptions");
    }
    elseif ($subscription_details['status']<1 && time()>$expire_time){
        // inactive and expired
        $rvi_subject=cms_site_name.' - Important Expiry Notice';

        $rvi_mail_body.="Your subscription below has expired or is at risk of expiring:\n\n-------------\n".$subscription_name_text."\n".$txt['subscription_renewal_instructions']."\n\n".user_login_link($user_details,"?myaccount=subscriptions");
        if (isset($txt['subscription_renewal_note']) && $txt['subscription_renewal_note']!=''){$rvi_mail_body.="\n\n".$txt['subscription_renewal_note'];}
    }
    else{

        $rvi_subject=cms_site_name.' - Important Renewal Reminder';

        $rvi_mail_body.="Your subscription below is due for renewal:\n\n-------------\n".$subscription_name_text."\n".$txt['subscription_renewal_instructions']."\n\n".user_login_link($user_details,"?myaccount=subscriptions");
        if (isset($txt['subscription_renewal_note']) && $txt['subscription_renewal_note']!=''){$rvi_mail_body.="\n\n".$txt['subscription_renewal_note'];}
    }

    $rvi_mail_body.="\n\n".cms_site_name."\n".cms_site_url;

    // privacy policy note
    $rvi_mail_body.="\n\n------------------------------------\nFor information on how we collect and use your data please read our privacy policy at ".cms_url."?terms#privacy";

?>
