<?php

// set the protocol in the admin area or override below - set to http:// or https:// if SSl cert is active on domain
// if changing protocol theme and cache must be reset in the admin area
// define('cms_protocol','http://');

// the cms tries to auto-detect the root directory and root url but you can manually set them here
// cms_root_dir and cms_root_url should end with a trailing slash
//define('cms_root_dir','');
//define('cms_root_url','http://www.mysite.com/cms/');

// backup method
// 0 will use phar backup if available (php5.3) with fall back to shell_exec tar method
// 1 will force shell_exec tar with gzip method (smaller file size and runs quicker but requires shell_exec and tar)
define('cms_backup_method',0);

// max upload limits that will generate an error if exceeded - note bigger images require more storage space and memory to process
define("MAX_UPLOAD_IMAGE_DIM",4000); // Max width and height dimension
define("MAX_UPLOAD_IMAGE_SIZE",2097152); // Max file size, 2097152 = 2MB
define("MAX_UPLOAD_FILE_SIZE",2048000); // Max file size, 2048000 = 2MB
// if uploaded images are bigger than those below a smaller resized version will be saved instead of original
define("MAX_UPLOADED_IMAGE_SIZE_X",960);
define("MAX_UPLOADED_IMAGE_SIZE_Y",700);
define("MAX_UPLOADED_IMAGE_SIZE",512000); // Max file size, 512000 = 500KB

// apply image watermarks - uses theme_dir/images/watermark.png
define("watermark_articles",0);
define("watermark_products",0);
define("watermark_listings",0);
define("watermark_applications",0);

// category defaults
define("category_default_listing_type",0); // 0=products, 1=user listings, 2=news
define("category_default_heading_visible",1);
define("category_default_description_visible",1);
define("category_default_menu_link_visible",1);

define("recent_category_default_format",0);
define("recent_category_default_columns",1);
define("recent_category_default_rows",3);
define("recent_category_default_tnx",140);
define("recent_category_default_tny",120);
define("recent_category_default_heading_visible",1);

// category limitations
define("category_max_cols",10);
define("category_max_rows",50);
define("category_min_tnx",40);
define("category_min_tny",40);
define("category_max_tnx",700);
define("category_max_tny",700);

// number of emails sent per batch - set to 0 to disable mailer
// to avoid exceeding server send limits keep this value as low as possible - recommended 5 to 10
define("mailer_batch_qty",0);  // 5
// mailer wait time in seconds
// to avoid exceeding server send limits keep this value as high as possible recommended 3600 (1hr)
define("mailer_interval",1800);

// enable/disable cache 0=off 1=on
define("cache_enabled",0);
// auto clear cache interval in seconds 0=off - should not need to be enabled except in special circumstances
define("clear_cache_interval",0);

// enable/disable listing expiry check  0=off or interval in seconds (86400 to check every 24hrs)
define("check_expired_listings",0);
// email expiry notifications for user listings - 0 to disable, 1 to email just on expiration, any number greater than 1 will send advance email(s) for listings that have less than this values number of days left
define("expired_listings_email_reminder",0);
// interval in days between email reminders - minimum value of 3 - expired_listings_email_reminder must be set to a value greater than 1
define("expired_listings_email_reminder_interval",15);

// enable/disable subscription expiry check  0=off or interval in seconds (86400 to check every 24hrs)
define("check_expired_subscriptions",0);
// email expiry notifications for subscriptions - 0 to disable, 1 to email just on expiration, any number greater than 1 will send advance email(s) for subscriptions that have less than this values number of days left
define("expired_subscriptions_email_reminder",0);
// interval in days between email reminders - minimum value of 3 - expired_subscriptions_email_reminder must be set to a value greater than 1
define("expired_subscriptions_email_reminder_interval",10);

// enable/disable friendly urls (0=off 1=on) this needs to be used with the friendly url .htaccess file 
define("friendly_urls",0);

// number of upload files allowed per message - 0=disable
define('message_max_upload_files',0);
// send emails via smtp server - if not used/specified emails will be sent via regular php mail
/*
define('smtp_host','smtp.mailgun.org');
define('smtp_port',465);
define('smtp_username','username');
define('smtp_password','password');
*/
// email system activity notifications to admin users - 1=enabled, 0=disabled
define('admin_email_notifications',0);

// type of email sent for messages
// 0=email notification with timer/login reset - login to read/reply via website
// 1=email every message imidiately with reply to sender
define('message_email_type',1);
// status for new messages 0=awaiting moderation, 1=approved, 2=spam
define('new_message_status',0);

// you can override the theme that has been set in the admin area for admin previewing of a new theme, only admins will be able to see the preview theme
// enter the name of the theme folder and set the minimum admin level for previewing - leave blank to display the selected theme in admin area
define('preview_theme',"");
define('preview_theme_adminlevel',10);

// setting this to true will remove the XT-CMS name and link from the admin area footer
define('white_label_footer',false);

?>