<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}

    // $cat_page_start is used for displaying category name and content
    if (!isset($item_num) || $item_num==$start_item){
         $cat_page_start="";
        // show search text as page heading if category is displaying search results
        if (isset($search) && !is_null($search)){
            $cat_page_start.="<h1>Search Results</h1>";
            if ($item_count<1){$cat_page_start.="<p>No articles found.</p>";}
            else {$cat_page_start.="<p>".$item_count." articles found.</p>";}
        }
        else{
            // display category name as page heading
            if ($category_details['heading_visible']>0 && $category_details['name']!=""){
                $cat_page_start.="<h1>".htmlspecialchars($category_details['name'])."</h1>";
            }
            // display category content
            if ($category_details['description_visible']>0 && $category_details['content']['main']!=""){
                $cat_page_start.="<div>".$category_details['content']['main']."</div>";
            }

            if ($category_details['listings_visible']>0 && $item_count<1){
                $cat_page_start.="<p>No articles found.</p>";
            }
        }

        // if there's no items to display just return
        if ($item_count<1){return;}

        // set variables on first item for all items
        // 90% width area divided by number of cols
        //$listing_width=90/$category_details['cols'];

        // open container for item listings - $items_output is used for displaying item listings
        $items_output.="<div class=\"news_listings\">";
    }

    $outer_border=1;
    $inner_border=5;


	$items_output.="<div class=\"news_listing\">";
    /*
    if ($thumbnail_fn!="none"){
        $items_output.="<div style=\"width: ".$category_details['tnx']."px; float: left\"><a href=\"".item_url('news',$display_items[$item_num]['id'],$item_details['slug'])."\"><img src=\"".cms_image_url.htmlspecialchars($thumbnail_fn)."\" width=\"".$image_size[0]."\" height=\"".$image_size[1]."\" alt=\"".htmlspecialchars($item_details['name'])."\" /></a></div>";
        $margin_left=" style=\"margin-left: ".($category_details['tnx']+15)."px;\"";
    }*/


    if ($thumbnail_fn!="none" && $image_size=getimagesize(sys_image_dir.'/'.$thumbnail_fn)){
        // thumbnail images are created 1.4 times bigger for any zooming effects
        $img_width=intval($image_size[0]/1.4);
        $img_height=intval($image_size[1]/1.4);
        $top=intval($category_details['tny']-$img_height)/2;
        $items_output.="<div class=\"img_cell\" style=\"float: left; max-width: ".($category_details['tnx']+($inner_border*2))."px; border: #b2b2b2 solid ".$outer_border."px; margin: 0 15px 10px 0\"><div style=\"border: #ffffff solid ".$inner_border."px;\"><a href=\"".item_url('news',$display_items[$item_num]['id'],$item_details['slug'])."\"><img src=\"".cms_image_url.htmlspecialchars($thumbnail_fn)."\" alt=\"".htmlspecialchars($item_details['name'])."\" style=\"max-width: ".$img_width."px;\" /></a></div></div>";
    }


    $items_output.="<div class=\"news_listing_name\"><a href=\"".item_url('news',$display_items[$item_num]['id'],$item_details['slug'])."\">".htmlspecialchars($item_details['name'])."</a></div>";
    if (strlen($item_details['content']['main'])>0){$items_output.="<div class=\"news_listing_description\">".substr(strip_tags($item_details['content']['main']),0,250)."... <a href=\"".item_url('news',$display_items[$item_num]['id'],$item_details['slug'])."\">read more</a></div>";}

    // get article owner name
    if (isset($item_details['customer_id'])){
        $customer_details=get_item_details('customer',$item_details['customer_id']);
        $article_owner=$customer_details['name'];
    }else{$article_owner='Admin';}

    // calculate number of days since update
    /*
    // not using because of caching inaccurate today/yesterday text
    $modified_time_midnight=mktime(0, 0, 0, date('m',$item_details['date']), date('d',$item_details['date']), date('Y',$item_details['date']));
    $num_of_days=(time()-$modified_time_midnight)/86400;
    if ($num_of_days<1){$post_time='Today';}
    elseif ($num_of_days<2){$post_time='Yesterday';}
    else {$post_time=date('jS F Y',$item_details['date']);}
    $items_output.="<div class=\"news_listing_date\">".$post_time." by ".$article_owner."</div>";
    */
    $items_output.="<div class=\"news_listing_date\">".date('jS F Y',$item_details['date'])." by ".$article_owner."</div>";

    $items_output.="<div style=\"clear: both\"></div></div>";

    // on last item close container div for item listings and display category page nav
    if ($item_num>=($max_item_num_page-1) || $item_num>=$last_item_num){
        $items_output.="</div>".$cat_page_nav;
    }

?>