<?php

	// exit if php file is loaded directly and not included
	if (!defined("cms_version_number")){exit();}

    /* this file is used to control the display of a category page content and listings */

    // $cat_page_start is used for displaying category name and content
    if (!isset($item_num) || $item_num==$start_item){
         $cat_page_start="";
        // show search text as page heading if category is displaying search results
        if (isset($search) && !is_null($search)){
            $cat_page_start.="<h1>Search Results</h1>";
            if ($item_count<1){$cat_page_start.="<p>No products found.</p>";}
            else {$cat_page_start.="<p>".$item_count." products found.</p>";}
        }
        else{
            // display category name as page heading
            if ($category_details['heading_visible']>0 && $category_details['name']!=""){
                $cat_page_start.="<h1>".htmlspecialchars($category_details['name'])."</h1>";
            }
            // display category content
            if ($category_details['description_visible']>0 && $category_details['content']['main']!=""){
                $cat_page_start.="<div>".$category_details['content']['main']."</div>";
            }

            if ($category_details['listings_visible']>0 && $item_count<1){
                $cat_page_start.="<p>No products found.</p>";
            }
        }

        // if there's no items to display just return
        if ($item_count<1){return;}

        // set variables on first item for all items
        // 90% width area divided by number of cols
        $listing_width=90/$category_details['cols'];

        // open container for item listings - $items_output is used for displaying item listings
        $items_output.="<div class=\"product_listings\">";
    }


    $items_output.="<div class=\"product_listing\" style=\"flex: 1 1 ".$listing_width."%\">";
    /*
    if ($thumbnail_fn!="none"){$items_output.="<a href=\"".item_url('product',$display_items[$item_num]['id'],$item_details['slug'])."\"><img src=\"".cms_image_url.htmlspecialchars($thumbnail_fn)."\" width=\"".$image_size[0]."\" height=\"".$image_size[1]."\" alt=\"".htmlspecialchars($item_details['name'])."\" /></a>";}
    else{$items_output.="No Image";}
    */
    if ($thumbnail_fn!="none" && $image_size=getimagesize(sys_image_dir.'/'.$thumbnail_fn)){
        // thumbnail images are created 1.4 times bigger for any zooming effects
        $img_width=intval($image_size[0]/1.4);
        $img_height=intval($image_size[1]/1.4);
        $top=intval($category_details['tny']-$img_height)/2;
        $items_output.="<div class=\"img_cell\" style=\"flex: 1 1 ".($category_details['tnx']+10)."px\"><div style=\"height: ".$category_details['tny']."px\"><a href=\"".item_url('product',$display_items[$item_num]['id'],$item_details['slug'])."\"><img src=\"".cms_image_url.htmlspecialchars($thumbnail_fn)."\" alt=\"".htmlspecialchars($item_details['name'])."\" /></a></div></div>";}
    else{
        $top_padding=intval($category_details['tny']/2);
        $items_output.="<div class=\"img_cell\" style=\"flex: 1 1 ".($category_details['tnx']+10)."px\"><div style=\"height: ".$category_details['tny']."px\">No Image</div></div>";
    }

    $items_output.="<div class=\"product_listing_detail\"><div class=\"product_name\"><a href=\"".item_url('product',$display_items[$item_num]['id'],$item_details['slug'])."\">".htmlspecialchars($item_details['name'])."</a></div>";
    if (isset($item_details['code']) && strlen($item_details['code'])>0){$items_output.="<div class=\"product_code\">".$item_details['code']."</div>";}
    if (isset($item_details['short_description']) && strlen($item_details['short_description'])>0){$items_output.="<div class=\"product_description\">".htmlspecialchars($item_details['short_description'])."</div>";}
    $items_output.="<div class=\"product_price\">$display_price</div>";
    $item_form="";
    if (strlen($display_options)>0){$item_form.="<div>".$display_options."</div>";}
    /*
    if ($cms_settings['shop_enabled']>0 && $item_details['behaviour']=='Add to Cart'){
    if ($item_details['note_form_enabled']>0 || $item_details['file_upload_enabled']>0){
    $items_output.="<div class=\"product_qty\"><b>Qty:</b> <input type=\"text\" name=\"qty\" value=\"1\" /></div>
            <div class=\"product_buy\"><input type=\"image\" src=\"".display_theme_file_loc('images/shop/add_to_cart.png',1)."\" style=\"padding-top: 5px\" /><input type=\"hidden\" name=\"product\" value=\"".$display_items[$item_num]['id']."\" /></div>";
    }
    else{
    $items_output.="<div class=\"product_qty\"><b>Qty:</b> <input type=\"text\" name=\"qty\" value=\"1\" /></div>
            <div class=\"product_buy\"><input type=\"image\" src=\"".display_theme_file_loc('images/shop/add_to_cart.png',1)."\" style=\"padding-top: 5px\" /><input type=\"hidden\" name=\"add_to_cart\" value=\"".$display_items[$item_num]['id']."\" /></div>";
    }
    }
    elseif(substr($item_details['behaviour'],0,7)=='Listing'){
        $items_output.="<div class=\"product_buy\"><input type=\"image\" src=\"".display_theme_file_loc('images/shop/continue.png',1)."\" style=\"padding-top: 5px\" /><input type=\"hidden\" name=\"product\" value=\"".$display_items[$item_num]['id']."\" /></div>";
    }
    */
    if ($item_details['behaviour']=='Add to Cart'){
        /*
        product status values
        0 = out of stock (auto)
        1 = in stock (auto+visible)
        2 = out of stock (visible)
        3 = out of stock (hidden)
        4 = in stock (hidden)
        */
        if ($item_details['status']==1){
            if ($item_details['note_form_enabled']>0 || $item_details['file_upload_enabled']>0){
                $item_form.="<div class=\"product_qty\">Qty: <input type=\"text\" name=\"qty\" value=\"1\" /></div>
                <div class=\"product_buy\"><a href=\"".item_url('product',$display_items[$item_num]['id'],$item_details['slug'])."\" class=\"btn btn_info\">".$txt['btn_more_info']."</a><button type=\"submit\" name=\"product\" value=\"".$display_items[$item_num]['id']."\" class=\"btn btn_add_to_cart\">".$txt['btn_add_to_cart']."</button></div>";
            }
            else{
                $item_form.="<div class=\"product_qty\">Qty: <input type=\"text\" name=\"qty\" value=\"1\" /></div>
                <div class=\"product_buy\"><a href=\"".item_url('product',$display_items[$item_num]['id'],$item_details['slug'])."\" class=\"btn btn_info\">".$txt['btn_more_info']."</a><button type=\"submit\" name=\"add_to_cart\" value=\"".$display_items[$item_num]['id']."\" class=\"btn btn_add_to_cart\">".$txt['btn_add_to_cart']."</button></div>";
            }
        }
        else{
            $item_form.="<div class=\"product_buy\"><a href=\"".item_url('product',$display_items[$item_num]['id'],$item_details['slug'])."\" class=\"btn btn_info\">".$txt['btn_more_info']."</a> Out of Stock</div>";
        }
    }
    elseif ($item_details['behaviour']=='Info Only'){
        $item_form.="<div class=\"product_buy\"><button type=\"submit\" name=\"product\" value=\"".$display_items[$item_num]['id']."\" class=\"btn btn_info\">".$txt['btn_more_info']."</button></div>";
    }
    elseif(substr($item_details['behaviour'],0,7)=='Listing' || substr($item_details['behaviour'],0,7)=='Application'){
        /*$item_form="<div class=\"product_buy\"><input type=\"image\" src=\"".display_theme_file_loc('images/shop/add_to_cart.png',1)."\" alt=\"Add to Cart\" style=\"padding-top: 5px\" /><input type=\"hidden\" name=\"product\" value=\"".$display_items[$item_num]['id']."\" /></div>";*/
        $item_form.="<div class=\"product_buy\"><button type=\"submit\" class=\"btn btn_add_to_cart\">".$txt['btn_add_to_cart']."</button><input type=\"hidden\" name=\"product\" value=\"".$display_items[$item_num]['id']."\" /></div>";
    }
    if (isset($item_form) && $item_form!=''){$items_output.="<form method=\"post\" class=\"product\">".$item_form."</form>";}

    // close container div for product_listing_detail
    $items_output.="</div>";

    // close container div for this item
    $items_output.="</div>";

    // on last item close container div for item listings and display category page nav
    if ($item_num>=($max_item_num_page-1) || $item_num>=$last_item_num){
        $items_output.="</div>".$cat_page_nav;
    }

?>